"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deserializeAws_json1_1DescribeACLsCommand = exports.deserializeAws_json1_1DeleteUserCommand = exports.deserializeAws_json1_1DeleteSubnetGroupCommand = exports.deserializeAws_json1_1DeleteSnapshotCommand = exports.deserializeAws_json1_1DeleteParameterGroupCommand = exports.deserializeAws_json1_1DeleteClusterCommand = exports.deserializeAws_json1_1DeleteACLCommand = exports.deserializeAws_json1_1CreateUserCommand = exports.deserializeAws_json1_1CreateSubnetGroupCommand = exports.deserializeAws_json1_1CreateSnapshotCommand = exports.deserializeAws_json1_1CreateParameterGroupCommand = exports.deserializeAws_json1_1CreateClusterCommand = exports.deserializeAws_json1_1CreateACLCommand = exports.deserializeAws_json1_1CopySnapshotCommand = exports.deserializeAws_json1_1BatchUpdateClusterCommand = exports.serializeAws_json1_1UpdateUserCommand = exports.serializeAws_json1_1UpdateSubnetGroupCommand = exports.serializeAws_json1_1UpdateParameterGroupCommand = exports.serializeAws_json1_1UpdateClusterCommand = exports.serializeAws_json1_1UpdateACLCommand = exports.serializeAws_json1_1UntagResourceCommand = exports.serializeAws_json1_1TagResourceCommand = exports.serializeAws_json1_1ResetParameterGroupCommand = exports.serializeAws_json1_1ListTagsCommand = exports.serializeAws_json1_1ListAllowedNodeTypeUpdatesCommand = exports.serializeAws_json1_1FailoverShardCommand = exports.serializeAws_json1_1DescribeUsersCommand = exports.serializeAws_json1_1DescribeSubnetGroupsCommand = exports.serializeAws_json1_1DescribeSnapshotsCommand = exports.serializeAws_json1_1DescribeServiceUpdatesCommand = exports.serializeAws_json1_1DescribeParametersCommand = exports.serializeAws_json1_1DescribeParameterGroupsCommand = exports.serializeAws_json1_1DescribeEventsCommand = exports.serializeAws_json1_1DescribeEngineVersionsCommand = exports.serializeAws_json1_1DescribeClustersCommand = exports.serializeAws_json1_1DescribeACLsCommand = exports.serializeAws_json1_1DeleteUserCommand = exports.serializeAws_json1_1DeleteSubnetGroupCommand = exports.serializeAws_json1_1DeleteSnapshotCommand = exports.serializeAws_json1_1DeleteParameterGroupCommand = exports.serializeAws_json1_1DeleteClusterCommand = exports.serializeAws_json1_1DeleteACLCommand = exports.serializeAws_json1_1CreateUserCommand = exports.serializeAws_json1_1CreateSubnetGroupCommand = exports.serializeAws_json1_1CreateSnapshotCommand = exports.serializeAws_json1_1CreateParameterGroupCommand = exports.serializeAws_json1_1CreateClusterCommand = exports.serializeAws_json1_1CreateACLCommand = exports.serializeAws_json1_1CopySnapshotCommand = exports.serializeAws_json1_1BatchUpdateClusterCommand = void 0;
exports.deserializeAws_json1_1UpdateUserCommand = exports.deserializeAws_json1_1UpdateSubnetGroupCommand = exports.deserializeAws_json1_1UpdateParameterGroupCommand = exports.deserializeAws_json1_1UpdateClusterCommand = exports.deserializeAws_json1_1UpdateACLCommand = exports.deserializeAws_json1_1UntagResourceCommand = exports.deserializeAws_json1_1TagResourceCommand = exports.deserializeAws_json1_1ResetParameterGroupCommand = exports.deserializeAws_json1_1ListTagsCommand = exports.deserializeAws_json1_1ListAllowedNodeTypeUpdatesCommand = exports.deserializeAws_json1_1FailoverShardCommand = exports.deserializeAws_json1_1DescribeUsersCommand = exports.deserializeAws_json1_1DescribeSubnetGroupsCommand = exports.deserializeAws_json1_1DescribeSnapshotsCommand = exports.deserializeAws_json1_1DescribeServiceUpdatesCommand = exports.deserializeAws_json1_1DescribeParametersCommand = exports.deserializeAws_json1_1DescribeParameterGroupsCommand = exports.deserializeAws_json1_1DescribeEventsCommand = exports.deserializeAws_json1_1DescribeEngineVersionsCommand = exports.deserializeAws_json1_1DescribeClustersCommand = void 0;
const protocol_http_1 = require("@aws-sdk/protocol-http");
const smithy_client_1 = require("@aws-sdk/smithy-client");
const MemoryDBServiceException_1 = require("../models/MemoryDBServiceException");
const models_0_1 = require("../models/models_0");
const serializeAws_json1_1BatchUpdateClusterCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.BatchUpdateCluster",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1BatchUpdateClusterRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1BatchUpdateClusterCommand = serializeAws_json1_1BatchUpdateClusterCommand;
const serializeAws_json1_1CopySnapshotCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.CopySnapshot",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1CopySnapshotRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1CopySnapshotCommand = serializeAws_json1_1CopySnapshotCommand;
const serializeAws_json1_1CreateACLCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.CreateACL",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1CreateACLRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1CreateACLCommand = serializeAws_json1_1CreateACLCommand;
const serializeAws_json1_1CreateClusterCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.CreateCluster",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1CreateClusterRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1CreateClusterCommand = serializeAws_json1_1CreateClusterCommand;
const serializeAws_json1_1CreateParameterGroupCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.CreateParameterGroup",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1CreateParameterGroupRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1CreateParameterGroupCommand = serializeAws_json1_1CreateParameterGroupCommand;
const serializeAws_json1_1CreateSnapshotCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.CreateSnapshot",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1CreateSnapshotRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1CreateSnapshotCommand = serializeAws_json1_1CreateSnapshotCommand;
const serializeAws_json1_1CreateSubnetGroupCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.CreateSubnetGroup",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1CreateSubnetGroupRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1CreateSubnetGroupCommand = serializeAws_json1_1CreateSubnetGroupCommand;
const serializeAws_json1_1CreateUserCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.CreateUser",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1CreateUserRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1CreateUserCommand = serializeAws_json1_1CreateUserCommand;
const serializeAws_json1_1DeleteACLCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.DeleteACL",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1DeleteACLRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1DeleteACLCommand = serializeAws_json1_1DeleteACLCommand;
const serializeAws_json1_1DeleteClusterCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.DeleteCluster",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1DeleteClusterRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1DeleteClusterCommand = serializeAws_json1_1DeleteClusterCommand;
const serializeAws_json1_1DeleteParameterGroupCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.DeleteParameterGroup",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1DeleteParameterGroupRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1DeleteParameterGroupCommand = serializeAws_json1_1DeleteParameterGroupCommand;
const serializeAws_json1_1DeleteSnapshotCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.DeleteSnapshot",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1DeleteSnapshotRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1DeleteSnapshotCommand = serializeAws_json1_1DeleteSnapshotCommand;
const serializeAws_json1_1DeleteSubnetGroupCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.DeleteSubnetGroup",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1DeleteSubnetGroupRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1DeleteSubnetGroupCommand = serializeAws_json1_1DeleteSubnetGroupCommand;
const serializeAws_json1_1DeleteUserCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.DeleteUser",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1DeleteUserRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1DeleteUserCommand = serializeAws_json1_1DeleteUserCommand;
const serializeAws_json1_1DescribeACLsCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.DescribeACLs",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1DescribeACLsRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1DescribeACLsCommand = serializeAws_json1_1DescribeACLsCommand;
const serializeAws_json1_1DescribeClustersCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.DescribeClusters",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1DescribeClustersRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1DescribeClustersCommand = serializeAws_json1_1DescribeClustersCommand;
const serializeAws_json1_1DescribeEngineVersionsCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.DescribeEngineVersions",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1DescribeEngineVersionsRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1DescribeEngineVersionsCommand = serializeAws_json1_1DescribeEngineVersionsCommand;
const serializeAws_json1_1DescribeEventsCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.DescribeEvents",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1DescribeEventsRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1DescribeEventsCommand = serializeAws_json1_1DescribeEventsCommand;
const serializeAws_json1_1DescribeParameterGroupsCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.DescribeParameterGroups",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1DescribeParameterGroupsRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1DescribeParameterGroupsCommand = serializeAws_json1_1DescribeParameterGroupsCommand;
const serializeAws_json1_1DescribeParametersCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.DescribeParameters",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1DescribeParametersRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1DescribeParametersCommand = serializeAws_json1_1DescribeParametersCommand;
const serializeAws_json1_1DescribeServiceUpdatesCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.DescribeServiceUpdates",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1DescribeServiceUpdatesRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1DescribeServiceUpdatesCommand = serializeAws_json1_1DescribeServiceUpdatesCommand;
const serializeAws_json1_1DescribeSnapshotsCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.DescribeSnapshots",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1DescribeSnapshotsRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1DescribeSnapshotsCommand = serializeAws_json1_1DescribeSnapshotsCommand;
const serializeAws_json1_1DescribeSubnetGroupsCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.DescribeSubnetGroups",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1DescribeSubnetGroupsRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1DescribeSubnetGroupsCommand = serializeAws_json1_1DescribeSubnetGroupsCommand;
const serializeAws_json1_1DescribeUsersCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.DescribeUsers",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1DescribeUsersRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1DescribeUsersCommand = serializeAws_json1_1DescribeUsersCommand;
const serializeAws_json1_1FailoverShardCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.FailoverShard",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1FailoverShardRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1FailoverShardCommand = serializeAws_json1_1FailoverShardCommand;
const serializeAws_json1_1ListAllowedNodeTypeUpdatesCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.ListAllowedNodeTypeUpdates",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1ListAllowedNodeTypeUpdatesRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1ListAllowedNodeTypeUpdatesCommand = serializeAws_json1_1ListAllowedNodeTypeUpdatesCommand;
const serializeAws_json1_1ListTagsCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.ListTags",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1ListTagsRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1ListTagsCommand = serializeAws_json1_1ListTagsCommand;
const serializeAws_json1_1ResetParameterGroupCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.ResetParameterGroup",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1ResetParameterGroupRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1ResetParameterGroupCommand = serializeAws_json1_1ResetParameterGroupCommand;
const serializeAws_json1_1TagResourceCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.TagResource",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1TagResourceRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1TagResourceCommand = serializeAws_json1_1TagResourceCommand;
const serializeAws_json1_1UntagResourceCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.UntagResource",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1UntagResourceRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1UntagResourceCommand = serializeAws_json1_1UntagResourceCommand;
const serializeAws_json1_1UpdateACLCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.UpdateACL",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1UpdateACLRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1UpdateACLCommand = serializeAws_json1_1UpdateACLCommand;
const serializeAws_json1_1UpdateClusterCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.UpdateCluster",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1UpdateClusterRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1UpdateClusterCommand = serializeAws_json1_1UpdateClusterCommand;
const serializeAws_json1_1UpdateParameterGroupCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.UpdateParameterGroup",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1UpdateParameterGroupRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1UpdateParameterGroupCommand = serializeAws_json1_1UpdateParameterGroupCommand;
const serializeAws_json1_1UpdateSubnetGroupCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.UpdateSubnetGroup",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1UpdateSubnetGroupRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1UpdateSubnetGroupCommand = serializeAws_json1_1UpdateSubnetGroupCommand;
const serializeAws_json1_1UpdateUserCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AmazonMemoryDB.UpdateUser",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1UpdateUserRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_1UpdateUserCommand = serializeAws_json1_1UpdateUserCommand;
const deserializeAws_json1_1BatchUpdateClusterCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1BatchUpdateClusterCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1BatchUpdateClusterResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1BatchUpdateClusterCommand = deserializeAws_json1_1BatchUpdateClusterCommand;
const deserializeAws_json1_1BatchUpdateClusterCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        case "ServiceUpdateNotFoundFault":
        case "com.amazonaws.memorydb#ServiceUpdateNotFoundFault":
            throw await deserializeAws_json1_1ServiceUpdateNotFoundFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1CopySnapshotCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1CopySnapshotCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1CopySnapshotResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1CopySnapshotCommand = deserializeAws_json1_1CopySnapshotCommand;
const deserializeAws_json1_1CopySnapshotCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidParameterCombinationException":
        case "com.amazonaws.memorydb#InvalidParameterCombinationException":
            throw await deserializeAws_json1_1InvalidParameterCombinationExceptionResponse(parsedOutput, context);
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        case "InvalidSnapshotStateFault":
        case "com.amazonaws.memorydb#InvalidSnapshotStateFault":
            throw await deserializeAws_json1_1InvalidSnapshotStateFaultResponse(parsedOutput, context);
        case "ServiceLinkedRoleNotFoundFault":
        case "com.amazonaws.memorydb#ServiceLinkedRoleNotFoundFault":
            throw await deserializeAws_json1_1ServiceLinkedRoleNotFoundFaultResponse(parsedOutput, context);
        case "SnapshotAlreadyExistsFault":
        case "com.amazonaws.memorydb#SnapshotAlreadyExistsFault":
            throw await deserializeAws_json1_1SnapshotAlreadyExistsFaultResponse(parsedOutput, context);
        case "SnapshotNotFoundFault":
        case "com.amazonaws.memorydb#SnapshotNotFoundFault":
            throw await deserializeAws_json1_1SnapshotNotFoundFaultResponse(parsedOutput, context);
        case "SnapshotQuotaExceededFault":
        case "com.amazonaws.memorydb#SnapshotQuotaExceededFault":
            throw await deserializeAws_json1_1SnapshotQuotaExceededFaultResponse(parsedOutput, context);
        case "TagQuotaPerResourceExceeded":
        case "com.amazonaws.memorydb#TagQuotaPerResourceExceeded":
            throw await deserializeAws_json1_1TagQuotaPerResourceExceededResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1CreateACLCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1CreateACLCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1CreateACLResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1CreateACLCommand = deserializeAws_json1_1CreateACLCommand;
const deserializeAws_json1_1CreateACLCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ACLAlreadyExistsFault":
        case "com.amazonaws.memorydb#ACLAlreadyExistsFault":
            throw await deserializeAws_json1_1ACLAlreadyExistsFaultResponse(parsedOutput, context);
        case "ACLQuotaExceededFault":
        case "com.amazonaws.memorydb#ACLQuotaExceededFault":
            throw await deserializeAws_json1_1ACLQuotaExceededFaultResponse(parsedOutput, context);
        case "DefaultUserRequired":
        case "com.amazonaws.memorydb#DefaultUserRequired":
            throw await deserializeAws_json1_1DefaultUserRequiredResponse(parsedOutput, context);
        case "DuplicateUserNameFault":
        case "com.amazonaws.memorydb#DuplicateUserNameFault":
            throw await deserializeAws_json1_1DuplicateUserNameFaultResponse(parsedOutput, context);
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        case "TagQuotaPerResourceExceeded":
        case "com.amazonaws.memorydb#TagQuotaPerResourceExceeded":
            throw await deserializeAws_json1_1TagQuotaPerResourceExceededResponse(parsedOutput, context);
        case "UserNotFoundFault":
        case "com.amazonaws.memorydb#UserNotFoundFault":
            throw await deserializeAws_json1_1UserNotFoundFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1CreateClusterCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1CreateClusterCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1CreateClusterResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1CreateClusterCommand = deserializeAws_json1_1CreateClusterCommand;
const deserializeAws_json1_1CreateClusterCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ACLNotFoundFault":
        case "com.amazonaws.memorydb#ACLNotFoundFault":
            throw await deserializeAws_json1_1ACLNotFoundFaultResponse(parsedOutput, context);
        case "ClusterAlreadyExistsFault":
        case "com.amazonaws.memorydb#ClusterAlreadyExistsFault":
            throw await deserializeAws_json1_1ClusterAlreadyExistsFaultResponse(parsedOutput, context);
        case "ClusterQuotaForCustomerExceededFault":
        case "com.amazonaws.memorydb#ClusterQuotaForCustomerExceededFault":
            throw await deserializeAws_json1_1ClusterQuotaForCustomerExceededFaultResponse(parsedOutput, context);
        case "InsufficientClusterCapacityFault":
        case "com.amazonaws.memorydb#InsufficientClusterCapacityFault":
            throw await deserializeAws_json1_1InsufficientClusterCapacityFaultResponse(parsedOutput, context);
        case "InvalidACLStateFault":
        case "com.amazonaws.memorydb#InvalidACLStateFault":
            throw await deserializeAws_json1_1InvalidACLStateFaultResponse(parsedOutput, context);
        case "InvalidCredentialsException":
        case "com.amazonaws.memorydb#InvalidCredentialsException":
            throw await deserializeAws_json1_1InvalidCredentialsExceptionResponse(parsedOutput, context);
        case "InvalidParameterCombinationException":
        case "com.amazonaws.memorydb#InvalidParameterCombinationException":
            throw await deserializeAws_json1_1InvalidParameterCombinationExceptionResponse(parsedOutput, context);
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        case "InvalidVPCNetworkStateFault":
        case "com.amazonaws.memorydb#InvalidVPCNetworkStateFault":
            throw await deserializeAws_json1_1InvalidVPCNetworkStateFaultResponse(parsedOutput, context);
        case "NodeQuotaForClusterExceededFault":
        case "com.amazonaws.memorydb#NodeQuotaForClusterExceededFault":
            throw await deserializeAws_json1_1NodeQuotaForClusterExceededFaultResponse(parsedOutput, context);
        case "NodeQuotaForCustomerExceededFault":
        case "com.amazonaws.memorydb#NodeQuotaForCustomerExceededFault":
            throw await deserializeAws_json1_1NodeQuotaForCustomerExceededFaultResponse(parsedOutput, context);
        case "ParameterGroupNotFoundFault":
        case "com.amazonaws.memorydb#ParameterGroupNotFoundFault":
            throw await deserializeAws_json1_1ParameterGroupNotFoundFaultResponse(parsedOutput, context);
        case "ServiceLinkedRoleNotFoundFault":
        case "com.amazonaws.memorydb#ServiceLinkedRoleNotFoundFault":
            throw await deserializeAws_json1_1ServiceLinkedRoleNotFoundFaultResponse(parsedOutput, context);
        case "ShardsPerClusterQuotaExceededFault":
        case "com.amazonaws.memorydb#ShardsPerClusterQuotaExceededFault":
            throw await deserializeAws_json1_1ShardsPerClusterQuotaExceededFaultResponse(parsedOutput, context);
        case "SubnetGroupNotFoundFault":
        case "com.amazonaws.memorydb#SubnetGroupNotFoundFault":
            throw await deserializeAws_json1_1SubnetGroupNotFoundFaultResponse(parsedOutput, context);
        case "TagQuotaPerResourceExceeded":
        case "com.amazonaws.memorydb#TagQuotaPerResourceExceeded":
            throw await deserializeAws_json1_1TagQuotaPerResourceExceededResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1CreateParameterGroupCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1CreateParameterGroupCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1CreateParameterGroupResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1CreateParameterGroupCommand = deserializeAws_json1_1CreateParameterGroupCommand;
const deserializeAws_json1_1CreateParameterGroupCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidParameterCombinationException":
        case "com.amazonaws.memorydb#InvalidParameterCombinationException":
            throw await deserializeAws_json1_1InvalidParameterCombinationExceptionResponse(parsedOutput, context);
        case "InvalidParameterGroupStateFault":
        case "com.amazonaws.memorydb#InvalidParameterGroupStateFault":
            throw await deserializeAws_json1_1InvalidParameterGroupStateFaultResponse(parsedOutput, context);
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        case "ParameterGroupAlreadyExistsFault":
        case "com.amazonaws.memorydb#ParameterGroupAlreadyExistsFault":
            throw await deserializeAws_json1_1ParameterGroupAlreadyExistsFaultResponse(parsedOutput, context);
        case "ParameterGroupQuotaExceededFault":
        case "com.amazonaws.memorydb#ParameterGroupQuotaExceededFault":
            throw await deserializeAws_json1_1ParameterGroupQuotaExceededFaultResponse(parsedOutput, context);
        case "ServiceLinkedRoleNotFoundFault":
        case "com.amazonaws.memorydb#ServiceLinkedRoleNotFoundFault":
            throw await deserializeAws_json1_1ServiceLinkedRoleNotFoundFaultResponse(parsedOutput, context);
        case "TagQuotaPerResourceExceeded":
        case "com.amazonaws.memorydb#TagQuotaPerResourceExceeded":
            throw await deserializeAws_json1_1TagQuotaPerResourceExceededResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1CreateSnapshotCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1CreateSnapshotCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1CreateSnapshotResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1CreateSnapshotCommand = deserializeAws_json1_1CreateSnapshotCommand;
const deserializeAws_json1_1CreateSnapshotCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ClusterNotFoundFault":
        case "com.amazonaws.memorydb#ClusterNotFoundFault":
            throw await deserializeAws_json1_1ClusterNotFoundFaultResponse(parsedOutput, context);
        case "InvalidClusterStateFault":
        case "com.amazonaws.memorydb#InvalidClusterStateFault":
            throw await deserializeAws_json1_1InvalidClusterStateFaultResponse(parsedOutput, context);
        case "InvalidParameterCombinationException":
        case "com.amazonaws.memorydb#InvalidParameterCombinationException":
            throw await deserializeAws_json1_1InvalidParameterCombinationExceptionResponse(parsedOutput, context);
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        case "ServiceLinkedRoleNotFoundFault":
        case "com.amazonaws.memorydb#ServiceLinkedRoleNotFoundFault":
            throw await deserializeAws_json1_1ServiceLinkedRoleNotFoundFaultResponse(parsedOutput, context);
        case "SnapshotAlreadyExistsFault":
        case "com.amazonaws.memorydb#SnapshotAlreadyExistsFault":
            throw await deserializeAws_json1_1SnapshotAlreadyExistsFaultResponse(parsedOutput, context);
        case "SnapshotQuotaExceededFault":
        case "com.amazonaws.memorydb#SnapshotQuotaExceededFault":
            throw await deserializeAws_json1_1SnapshotQuotaExceededFaultResponse(parsedOutput, context);
        case "TagQuotaPerResourceExceeded":
        case "com.amazonaws.memorydb#TagQuotaPerResourceExceeded":
            throw await deserializeAws_json1_1TagQuotaPerResourceExceededResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1CreateSubnetGroupCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1CreateSubnetGroupCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1CreateSubnetGroupResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1CreateSubnetGroupCommand = deserializeAws_json1_1CreateSubnetGroupCommand;
const deserializeAws_json1_1CreateSubnetGroupCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidSubnet":
        case "com.amazonaws.memorydb#InvalidSubnet":
            throw await deserializeAws_json1_1InvalidSubnetResponse(parsedOutput, context);
        case "ServiceLinkedRoleNotFoundFault":
        case "com.amazonaws.memorydb#ServiceLinkedRoleNotFoundFault":
            throw await deserializeAws_json1_1ServiceLinkedRoleNotFoundFaultResponse(parsedOutput, context);
        case "SubnetGroupAlreadyExistsFault":
        case "com.amazonaws.memorydb#SubnetGroupAlreadyExistsFault":
            throw await deserializeAws_json1_1SubnetGroupAlreadyExistsFaultResponse(parsedOutput, context);
        case "SubnetGroupQuotaExceededFault":
        case "com.amazonaws.memorydb#SubnetGroupQuotaExceededFault":
            throw await deserializeAws_json1_1SubnetGroupQuotaExceededFaultResponse(parsedOutput, context);
        case "SubnetNotAllowedFault":
        case "com.amazonaws.memorydb#SubnetNotAllowedFault":
            throw await deserializeAws_json1_1SubnetNotAllowedFaultResponse(parsedOutput, context);
        case "SubnetQuotaExceededFault":
        case "com.amazonaws.memorydb#SubnetQuotaExceededFault":
            throw await deserializeAws_json1_1SubnetQuotaExceededFaultResponse(parsedOutput, context);
        case "TagQuotaPerResourceExceeded":
        case "com.amazonaws.memorydb#TagQuotaPerResourceExceeded":
            throw await deserializeAws_json1_1TagQuotaPerResourceExceededResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1CreateUserCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1CreateUserCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1CreateUserResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1CreateUserCommand = deserializeAws_json1_1CreateUserCommand;
const deserializeAws_json1_1CreateUserCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "DuplicateUserNameFault":
        case "com.amazonaws.memorydb#DuplicateUserNameFault":
            throw await deserializeAws_json1_1DuplicateUserNameFaultResponse(parsedOutput, context);
        case "InvalidParameterCombinationException":
        case "com.amazonaws.memorydb#InvalidParameterCombinationException":
            throw await deserializeAws_json1_1InvalidParameterCombinationExceptionResponse(parsedOutput, context);
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        case "TagQuotaPerResourceExceeded":
        case "com.amazonaws.memorydb#TagQuotaPerResourceExceeded":
            throw await deserializeAws_json1_1TagQuotaPerResourceExceededResponse(parsedOutput, context);
        case "UserAlreadyExistsFault":
        case "com.amazonaws.memorydb#UserAlreadyExistsFault":
            throw await deserializeAws_json1_1UserAlreadyExistsFaultResponse(parsedOutput, context);
        case "UserQuotaExceededFault":
        case "com.amazonaws.memorydb#UserQuotaExceededFault":
            throw await deserializeAws_json1_1UserQuotaExceededFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1DeleteACLCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1DeleteACLCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1DeleteACLResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1DeleteACLCommand = deserializeAws_json1_1DeleteACLCommand;
const deserializeAws_json1_1DeleteACLCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ACLNotFoundFault":
        case "com.amazonaws.memorydb#ACLNotFoundFault":
            throw await deserializeAws_json1_1ACLNotFoundFaultResponse(parsedOutput, context);
        case "InvalidACLStateFault":
        case "com.amazonaws.memorydb#InvalidACLStateFault":
            throw await deserializeAws_json1_1InvalidACLStateFaultResponse(parsedOutput, context);
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1DeleteClusterCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1DeleteClusterCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1DeleteClusterResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1DeleteClusterCommand = deserializeAws_json1_1DeleteClusterCommand;
const deserializeAws_json1_1DeleteClusterCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ClusterNotFoundFault":
        case "com.amazonaws.memorydb#ClusterNotFoundFault":
            throw await deserializeAws_json1_1ClusterNotFoundFaultResponse(parsedOutput, context);
        case "InvalidClusterStateFault":
        case "com.amazonaws.memorydb#InvalidClusterStateFault":
            throw await deserializeAws_json1_1InvalidClusterStateFaultResponse(parsedOutput, context);
        case "InvalidParameterCombinationException":
        case "com.amazonaws.memorydb#InvalidParameterCombinationException":
            throw await deserializeAws_json1_1InvalidParameterCombinationExceptionResponse(parsedOutput, context);
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        case "ServiceLinkedRoleNotFoundFault":
        case "com.amazonaws.memorydb#ServiceLinkedRoleNotFoundFault":
            throw await deserializeAws_json1_1ServiceLinkedRoleNotFoundFaultResponse(parsedOutput, context);
        case "SnapshotAlreadyExistsFault":
        case "com.amazonaws.memorydb#SnapshotAlreadyExistsFault":
            throw await deserializeAws_json1_1SnapshotAlreadyExistsFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1DeleteParameterGroupCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1DeleteParameterGroupCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1DeleteParameterGroupResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1DeleteParameterGroupCommand = deserializeAws_json1_1DeleteParameterGroupCommand;
const deserializeAws_json1_1DeleteParameterGroupCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidParameterCombinationException":
        case "com.amazonaws.memorydb#InvalidParameterCombinationException":
            throw await deserializeAws_json1_1InvalidParameterCombinationExceptionResponse(parsedOutput, context);
        case "InvalidParameterGroupStateFault":
        case "com.amazonaws.memorydb#InvalidParameterGroupStateFault":
            throw await deserializeAws_json1_1InvalidParameterGroupStateFaultResponse(parsedOutput, context);
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        case "ParameterGroupNotFoundFault":
        case "com.amazonaws.memorydb#ParameterGroupNotFoundFault":
            throw await deserializeAws_json1_1ParameterGroupNotFoundFaultResponse(parsedOutput, context);
        case "ServiceLinkedRoleNotFoundFault":
        case "com.amazonaws.memorydb#ServiceLinkedRoleNotFoundFault":
            throw await deserializeAws_json1_1ServiceLinkedRoleNotFoundFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1DeleteSnapshotCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1DeleteSnapshotCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1DeleteSnapshotResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1DeleteSnapshotCommand = deserializeAws_json1_1DeleteSnapshotCommand;
const deserializeAws_json1_1DeleteSnapshotCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidParameterCombinationException":
        case "com.amazonaws.memorydb#InvalidParameterCombinationException":
            throw await deserializeAws_json1_1InvalidParameterCombinationExceptionResponse(parsedOutput, context);
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        case "InvalidSnapshotStateFault":
        case "com.amazonaws.memorydb#InvalidSnapshotStateFault":
            throw await deserializeAws_json1_1InvalidSnapshotStateFaultResponse(parsedOutput, context);
        case "ServiceLinkedRoleNotFoundFault":
        case "com.amazonaws.memorydb#ServiceLinkedRoleNotFoundFault":
            throw await deserializeAws_json1_1ServiceLinkedRoleNotFoundFaultResponse(parsedOutput, context);
        case "SnapshotNotFoundFault":
        case "com.amazonaws.memorydb#SnapshotNotFoundFault":
            throw await deserializeAws_json1_1SnapshotNotFoundFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1DeleteSubnetGroupCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1DeleteSubnetGroupCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1DeleteSubnetGroupResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1DeleteSubnetGroupCommand = deserializeAws_json1_1DeleteSubnetGroupCommand;
const deserializeAws_json1_1DeleteSubnetGroupCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ServiceLinkedRoleNotFoundFault":
        case "com.amazonaws.memorydb#ServiceLinkedRoleNotFoundFault":
            throw await deserializeAws_json1_1ServiceLinkedRoleNotFoundFaultResponse(parsedOutput, context);
        case "SubnetGroupInUseFault":
        case "com.amazonaws.memorydb#SubnetGroupInUseFault":
            throw await deserializeAws_json1_1SubnetGroupInUseFaultResponse(parsedOutput, context);
        case "SubnetGroupNotFoundFault":
        case "com.amazonaws.memorydb#SubnetGroupNotFoundFault":
            throw await deserializeAws_json1_1SubnetGroupNotFoundFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1DeleteUserCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1DeleteUserCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1DeleteUserResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1DeleteUserCommand = deserializeAws_json1_1DeleteUserCommand;
const deserializeAws_json1_1DeleteUserCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        case "InvalidUserStateFault":
        case "com.amazonaws.memorydb#InvalidUserStateFault":
            throw await deserializeAws_json1_1InvalidUserStateFaultResponse(parsedOutput, context);
        case "UserNotFoundFault":
        case "com.amazonaws.memorydb#UserNotFoundFault":
            throw await deserializeAws_json1_1UserNotFoundFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1DescribeACLsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1DescribeACLsCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1DescribeACLsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1DescribeACLsCommand = deserializeAws_json1_1DescribeACLsCommand;
const deserializeAws_json1_1DescribeACLsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ACLNotFoundFault":
        case "com.amazonaws.memorydb#ACLNotFoundFault":
            throw await deserializeAws_json1_1ACLNotFoundFaultResponse(parsedOutput, context);
        case "InvalidParameterCombinationException":
        case "com.amazonaws.memorydb#InvalidParameterCombinationException":
            throw await deserializeAws_json1_1InvalidParameterCombinationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1DescribeClustersCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1DescribeClustersCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1DescribeClustersResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1DescribeClustersCommand = deserializeAws_json1_1DescribeClustersCommand;
const deserializeAws_json1_1DescribeClustersCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ClusterNotFoundFault":
        case "com.amazonaws.memorydb#ClusterNotFoundFault":
            throw await deserializeAws_json1_1ClusterNotFoundFaultResponse(parsedOutput, context);
        case "InvalidParameterCombinationException":
        case "com.amazonaws.memorydb#InvalidParameterCombinationException":
            throw await deserializeAws_json1_1InvalidParameterCombinationExceptionResponse(parsedOutput, context);
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        case "ServiceLinkedRoleNotFoundFault":
        case "com.amazonaws.memorydb#ServiceLinkedRoleNotFoundFault":
            throw await deserializeAws_json1_1ServiceLinkedRoleNotFoundFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1DescribeEngineVersionsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1DescribeEngineVersionsCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1DescribeEngineVersionsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1DescribeEngineVersionsCommand = deserializeAws_json1_1DescribeEngineVersionsCommand;
const deserializeAws_json1_1DescribeEngineVersionsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidParameterCombinationException":
        case "com.amazonaws.memorydb#InvalidParameterCombinationException":
            throw await deserializeAws_json1_1InvalidParameterCombinationExceptionResponse(parsedOutput, context);
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        case "ServiceLinkedRoleNotFoundFault":
        case "com.amazonaws.memorydb#ServiceLinkedRoleNotFoundFault":
            throw await deserializeAws_json1_1ServiceLinkedRoleNotFoundFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1DescribeEventsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1DescribeEventsCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1DescribeEventsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1DescribeEventsCommand = deserializeAws_json1_1DescribeEventsCommand;
const deserializeAws_json1_1DescribeEventsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidParameterCombinationException":
        case "com.amazonaws.memorydb#InvalidParameterCombinationException":
            throw await deserializeAws_json1_1InvalidParameterCombinationExceptionResponse(parsedOutput, context);
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        case "ServiceLinkedRoleNotFoundFault":
        case "com.amazonaws.memorydb#ServiceLinkedRoleNotFoundFault":
            throw await deserializeAws_json1_1ServiceLinkedRoleNotFoundFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1DescribeParameterGroupsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1DescribeParameterGroupsCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1DescribeParameterGroupsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1DescribeParameterGroupsCommand = deserializeAws_json1_1DescribeParameterGroupsCommand;
const deserializeAws_json1_1DescribeParameterGroupsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidParameterCombinationException":
        case "com.amazonaws.memorydb#InvalidParameterCombinationException":
            throw await deserializeAws_json1_1InvalidParameterCombinationExceptionResponse(parsedOutput, context);
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        case "ParameterGroupNotFoundFault":
        case "com.amazonaws.memorydb#ParameterGroupNotFoundFault":
            throw await deserializeAws_json1_1ParameterGroupNotFoundFaultResponse(parsedOutput, context);
        case "ServiceLinkedRoleNotFoundFault":
        case "com.amazonaws.memorydb#ServiceLinkedRoleNotFoundFault":
            throw await deserializeAws_json1_1ServiceLinkedRoleNotFoundFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1DescribeParametersCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1DescribeParametersCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1DescribeParametersResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1DescribeParametersCommand = deserializeAws_json1_1DescribeParametersCommand;
const deserializeAws_json1_1DescribeParametersCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidParameterCombinationException":
        case "com.amazonaws.memorydb#InvalidParameterCombinationException":
            throw await deserializeAws_json1_1InvalidParameterCombinationExceptionResponse(parsedOutput, context);
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        case "ParameterGroupNotFoundFault":
        case "com.amazonaws.memorydb#ParameterGroupNotFoundFault":
            throw await deserializeAws_json1_1ParameterGroupNotFoundFaultResponse(parsedOutput, context);
        case "ServiceLinkedRoleNotFoundFault":
        case "com.amazonaws.memorydb#ServiceLinkedRoleNotFoundFault":
            throw await deserializeAws_json1_1ServiceLinkedRoleNotFoundFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1DescribeServiceUpdatesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1DescribeServiceUpdatesCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1DescribeServiceUpdatesResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1DescribeServiceUpdatesCommand = deserializeAws_json1_1DescribeServiceUpdatesCommand;
const deserializeAws_json1_1DescribeServiceUpdatesCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidParameterCombinationException":
        case "com.amazonaws.memorydb#InvalidParameterCombinationException":
            throw await deserializeAws_json1_1InvalidParameterCombinationExceptionResponse(parsedOutput, context);
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1DescribeSnapshotsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1DescribeSnapshotsCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1DescribeSnapshotsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1DescribeSnapshotsCommand = deserializeAws_json1_1DescribeSnapshotsCommand;
const deserializeAws_json1_1DescribeSnapshotsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidParameterCombinationException":
        case "com.amazonaws.memorydb#InvalidParameterCombinationException":
            throw await deserializeAws_json1_1InvalidParameterCombinationExceptionResponse(parsedOutput, context);
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        case "ServiceLinkedRoleNotFoundFault":
        case "com.amazonaws.memorydb#ServiceLinkedRoleNotFoundFault":
            throw await deserializeAws_json1_1ServiceLinkedRoleNotFoundFaultResponse(parsedOutput, context);
        case "SnapshotNotFoundFault":
        case "com.amazonaws.memorydb#SnapshotNotFoundFault":
            throw await deserializeAws_json1_1SnapshotNotFoundFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1DescribeSubnetGroupsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1DescribeSubnetGroupsCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1DescribeSubnetGroupsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1DescribeSubnetGroupsCommand = deserializeAws_json1_1DescribeSubnetGroupsCommand;
const deserializeAws_json1_1DescribeSubnetGroupsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ServiceLinkedRoleNotFoundFault":
        case "com.amazonaws.memorydb#ServiceLinkedRoleNotFoundFault":
            throw await deserializeAws_json1_1ServiceLinkedRoleNotFoundFaultResponse(parsedOutput, context);
        case "SubnetGroupNotFoundFault":
        case "com.amazonaws.memorydb#SubnetGroupNotFoundFault":
            throw await deserializeAws_json1_1SubnetGroupNotFoundFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1DescribeUsersCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1DescribeUsersCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1DescribeUsersResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1DescribeUsersCommand = deserializeAws_json1_1DescribeUsersCommand;
const deserializeAws_json1_1DescribeUsersCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidParameterCombinationException":
        case "com.amazonaws.memorydb#InvalidParameterCombinationException":
            throw await deserializeAws_json1_1InvalidParameterCombinationExceptionResponse(parsedOutput, context);
        case "UserNotFoundFault":
        case "com.amazonaws.memorydb#UserNotFoundFault":
            throw await deserializeAws_json1_1UserNotFoundFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1FailoverShardCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1FailoverShardCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1FailoverShardResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1FailoverShardCommand = deserializeAws_json1_1FailoverShardCommand;
const deserializeAws_json1_1FailoverShardCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "APICallRateForCustomerExceededFault":
        case "com.amazonaws.memorydb#APICallRateForCustomerExceededFault":
            throw await deserializeAws_json1_1APICallRateForCustomerExceededFaultResponse(parsedOutput, context);
        case "ClusterNotFoundFault":
        case "com.amazonaws.memorydb#ClusterNotFoundFault":
            throw await deserializeAws_json1_1ClusterNotFoundFaultResponse(parsedOutput, context);
        case "InvalidClusterStateFault":
        case "com.amazonaws.memorydb#InvalidClusterStateFault":
            throw await deserializeAws_json1_1InvalidClusterStateFaultResponse(parsedOutput, context);
        case "InvalidKMSKeyFault":
        case "com.amazonaws.memorydb#InvalidKMSKeyFault":
            throw await deserializeAws_json1_1InvalidKMSKeyFaultResponse(parsedOutput, context);
        case "InvalidParameterCombinationException":
        case "com.amazonaws.memorydb#InvalidParameterCombinationException":
            throw await deserializeAws_json1_1InvalidParameterCombinationExceptionResponse(parsedOutput, context);
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        case "ShardNotFoundFault":
        case "com.amazonaws.memorydb#ShardNotFoundFault":
            throw await deserializeAws_json1_1ShardNotFoundFaultResponse(parsedOutput, context);
        case "TestFailoverNotAvailableFault":
        case "com.amazonaws.memorydb#TestFailoverNotAvailableFault":
            throw await deserializeAws_json1_1TestFailoverNotAvailableFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1ListAllowedNodeTypeUpdatesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1ListAllowedNodeTypeUpdatesCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1ListAllowedNodeTypeUpdatesResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1ListAllowedNodeTypeUpdatesCommand = deserializeAws_json1_1ListAllowedNodeTypeUpdatesCommand;
const deserializeAws_json1_1ListAllowedNodeTypeUpdatesCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ClusterNotFoundFault":
        case "com.amazonaws.memorydb#ClusterNotFoundFault":
            throw await deserializeAws_json1_1ClusterNotFoundFaultResponse(parsedOutput, context);
        case "InvalidParameterCombinationException":
        case "com.amazonaws.memorydb#InvalidParameterCombinationException":
            throw await deserializeAws_json1_1InvalidParameterCombinationExceptionResponse(parsedOutput, context);
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        case "ServiceLinkedRoleNotFoundFault":
        case "com.amazonaws.memorydb#ServiceLinkedRoleNotFoundFault":
            throw await deserializeAws_json1_1ServiceLinkedRoleNotFoundFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1ListTagsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1ListTagsCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1ListTagsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1ListTagsCommand = deserializeAws_json1_1ListTagsCommand;
const deserializeAws_json1_1ListTagsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ACLNotFoundFault":
        case "com.amazonaws.memorydb#ACLNotFoundFault":
            throw await deserializeAws_json1_1ACLNotFoundFaultResponse(parsedOutput, context);
        case "ClusterNotFoundFault":
        case "com.amazonaws.memorydb#ClusterNotFoundFault":
            throw await deserializeAws_json1_1ClusterNotFoundFaultResponse(parsedOutput, context);
        case "InvalidARNFault":
        case "com.amazonaws.memorydb#InvalidARNFault":
            throw await deserializeAws_json1_1InvalidARNFaultResponse(parsedOutput, context);
        case "InvalidClusterStateFault":
        case "com.amazonaws.memorydb#InvalidClusterStateFault":
            throw await deserializeAws_json1_1InvalidClusterStateFaultResponse(parsedOutput, context);
        case "ParameterGroupNotFoundFault":
        case "com.amazonaws.memorydb#ParameterGroupNotFoundFault":
            throw await deserializeAws_json1_1ParameterGroupNotFoundFaultResponse(parsedOutput, context);
        case "ServiceLinkedRoleNotFoundFault":
        case "com.amazonaws.memorydb#ServiceLinkedRoleNotFoundFault":
            throw await deserializeAws_json1_1ServiceLinkedRoleNotFoundFaultResponse(parsedOutput, context);
        case "SnapshotNotFoundFault":
        case "com.amazonaws.memorydb#SnapshotNotFoundFault":
            throw await deserializeAws_json1_1SnapshotNotFoundFaultResponse(parsedOutput, context);
        case "SubnetGroupNotFoundFault":
        case "com.amazonaws.memorydb#SubnetGroupNotFoundFault":
            throw await deserializeAws_json1_1SubnetGroupNotFoundFaultResponse(parsedOutput, context);
        case "UserNotFoundFault":
        case "com.amazonaws.memorydb#UserNotFoundFault":
            throw await deserializeAws_json1_1UserNotFoundFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1ResetParameterGroupCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1ResetParameterGroupCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1ResetParameterGroupResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1ResetParameterGroupCommand = deserializeAws_json1_1ResetParameterGroupCommand;
const deserializeAws_json1_1ResetParameterGroupCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidParameterCombinationException":
        case "com.amazonaws.memorydb#InvalidParameterCombinationException":
            throw await deserializeAws_json1_1InvalidParameterCombinationExceptionResponse(parsedOutput, context);
        case "InvalidParameterGroupStateFault":
        case "com.amazonaws.memorydb#InvalidParameterGroupStateFault":
            throw await deserializeAws_json1_1InvalidParameterGroupStateFaultResponse(parsedOutput, context);
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        case "ParameterGroupNotFoundFault":
        case "com.amazonaws.memorydb#ParameterGroupNotFoundFault":
            throw await deserializeAws_json1_1ParameterGroupNotFoundFaultResponse(parsedOutput, context);
        case "ServiceLinkedRoleNotFoundFault":
        case "com.amazonaws.memorydb#ServiceLinkedRoleNotFoundFault":
            throw await deserializeAws_json1_1ServiceLinkedRoleNotFoundFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1TagResourceCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1TagResourceCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1TagResourceResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1TagResourceCommand = deserializeAws_json1_1TagResourceCommand;
const deserializeAws_json1_1TagResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ACLNotFoundFault":
        case "com.amazonaws.memorydb#ACLNotFoundFault":
            throw await deserializeAws_json1_1ACLNotFoundFaultResponse(parsedOutput, context);
        case "ClusterNotFoundFault":
        case "com.amazonaws.memorydb#ClusterNotFoundFault":
            throw await deserializeAws_json1_1ClusterNotFoundFaultResponse(parsedOutput, context);
        case "InvalidARNFault":
        case "com.amazonaws.memorydb#InvalidARNFault":
            throw await deserializeAws_json1_1InvalidARNFaultResponse(parsedOutput, context);
        case "InvalidClusterStateFault":
        case "com.amazonaws.memorydb#InvalidClusterStateFault":
            throw await deserializeAws_json1_1InvalidClusterStateFaultResponse(parsedOutput, context);
        case "ParameterGroupNotFoundFault":
        case "com.amazonaws.memorydb#ParameterGroupNotFoundFault":
            throw await deserializeAws_json1_1ParameterGroupNotFoundFaultResponse(parsedOutput, context);
        case "ServiceLinkedRoleNotFoundFault":
        case "com.amazonaws.memorydb#ServiceLinkedRoleNotFoundFault":
            throw await deserializeAws_json1_1ServiceLinkedRoleNotFoundFaultResponse(parsedOutput, context);
        case "SnapshotNotFoundFault":
        case "com.amazonaws.memorydb#SnapshotNotFoundFault":
            throw await deserializeAws_json1_1SnapshotNotFoundFaultResponse(parsedOutput, context);
        case "SubnetGroupNotFoundFault":
        case "com.amazonaws.memorydb#SubnetGroupNotFoundFault":
            throw await deserializeAws_json1_1SubnetGroupNotFoundFaultResponse(parsedOutput, context);
        case "TagQuotaPerResourceExceeded":
        case "com.amazonaws.memorydb#TagQuotaPerResourceExceeded":
            throw await deserializeAws_json1_1TagQuotaPerResourceExceededResponse(parsedOutput, context);
        case "UserNotFoundFault":
        case "com.amazonaws.memorydb#UserNotFoundFault":
            throw await deserializeAws_json1_1UserNotFoundFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1UntagResourceCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1UntagResourceCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1UntagResourceResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1UntagResourceCommand = deserializeAws_json1_1UntagResourceCommand;
const deserializeAws_json1_1UntagResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ACLNotFoundFault":
        case "com.amazonaws.memorydb#ACLNotFoundFault":
            throw await deserializeAws_json1_1ACLNotFoundFaultResponse(parsedOutput, context);
        case "ClusterNotFoundFault":
        case "com.amazonaws.memorydb#ClusterNotFoundFault":
            throw await deserializeAws_json1_1ClusterNotFoundFaultResponse(parsedOutput, context);
        case "InvalidARNFault":
        case "com.amazonaws.memorydb#InvalidARNFault":
            throw await deserializeAws_json1_1InvalidARNFaultResponse(parsedOutput, context);
        case "InvalidClusterStateFault":
        case "com.amazonaws.memorydb#InvalidClusterStateFault":
            throw await deserializeAws_json1_1InvalidClusterStateFaultResponse(parsedOutput, context);
        case "ParameterGroupNotFoundFault":
        case "com.amazonaws.memorydb#ParameterGroupNotFoundFault":
            throw await deserializeAws_json1_1ParameterGroupNotFoundFaultResponse(parsedOutput, context);
        case "ServiceLinkedRoleNotFoundFault":
        case "com.amazonaws.memorydb#ServiceLinkedRoleNotFoundFault":
            throw await deserializeAws_json1_1ServiceLinkedRoleNotFoundFaultResponse(parsedOutput, context);
        case "SnapshotNotFoundFault":
        case "com.amazonaws.memorydb#SnapshotNotFoundFault":
            throw await deserializeAws_json1_1SnapshotNotFoundFaultResponse(parsedOutput, context);
        case "SubnetGroupNotFoundFault":
        case "com.amazonaws.memorydb#SubnetGroupNotFoundFault":
            throw await deserializeAws_json1_1SubnetGroupNotFoundFaultResponse(parsedOutput, context);
        case "TagNotFoundFault":
        case "com.amazonaws.memorydb#TagNotFoundFault":
            throw await deserializeAws_json1_1TagNotFoundFaultResponse(parsedOutput, context);
        case "UserNotFoundFault":
        case "com.amazonaws.memorydb#UserNotFoundFault":
            throw await deserializeAws_json1_1UserNotFoundFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1UpdateACLCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1UpdateACLCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1UpdateACLResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1UpdateACLCommand = deserializeAws_json1_1UpdateACLCommand;
const deserializeAws_json1_1UpdateACLCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ACLNotFoundFault":
        case "com.amazonaws.memorydb#ACLNotFoundFault":
            throw await deserializeAws_json1_1ACLNotFoundFaultResponse(parsedOutput, context);
        case "DefaultUserRequired":
        case "com.amazonaws.memorydb#DefaultUserRequired":
            throw await deserializeAws_json1_1DefaultUserRequiredResponse(parsedOutput, context);
        case "DuplicateUserNameFault":
        case "com.amazonaws.memorydb#DuplicateUserNameFault":
            throw await deserializeAws_json1_1DuplicateUserNameFaultResponse(parsedOutput, context);
        case "InvalidACLStateFault":
        case "com.amazonaws.memorydb#InvalidACLStateFault":
            throw await deserializeAws_json1_1InvalidACLStateFaultResponse(parsedOutput, context);
        case "InvalidParameterCombinationException":
        case "com.amazonaws.memorydb#InvalidParameterCombinationException":
            throw await deserializeAws_json1_1InvalidParameterCombinationExceptionResponse(parsedOutput, context);
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        case "UserNotFoundFault":
        case "com.amazonaws.memorydb#UserNotFoundFault":
            throw await deserializeAws_json1_1UserNotFoundFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1UpdateClusterCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1UpdateClusterCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1UpdateClusterResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1UpdateClusterCommand = deserializeAws_json1_1UpdateClusterCommand;
const deserializeAws_json1_1UpdateClusterCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ACLNotFoundFault":
        case "com.amazonaws.memorydb#ACLNotFoundFault":
            throw await deserializeAws_json1_1ACLNotFoundFaultResponse(parsedOutput, context);
        case "ClusterNotFoundFault":
        case "com.amazonaws.memorydb#ClusterNotFoundFault":
            throw await deserializeAws_json1_1ClusterNotFoundFaultResponse(parsedOutput, context);
        case "ClusterQuotaForCustomerExceededFault":
        case "com.amazonaws.memorydb#ClusterQuotaForCustomerExceededFault":
            throw await deserializeAws_json1_1ClusterQuotaForCustomerExceededFaultResponse(parsedOutput, context);
        case "InvalidACLStateFault":
        case "com.amazonaws.memorydb#InvalidACLStateFault":
            throw await deserializeAws_json1_1InvalidACLStateFaultResponse(parsedOutput, context);
        case "InvalidClusterStateFault":
        case "com.amazonaws.memorydb#InvalidClusterStateFault":
            throw await deserializeAws_json1_1InvalidClusterStateFaultResponse(parsedOutput, context);
        case "InvalidKMSKeyFault":
        case "com.amazonaws.memorydb#InvalidKMSKeyFault":
            throw await deserializeAws_json1_1InvalidKMSKeyFaultResponse(parsedOutput, context);
        case "InvalidNodeStateFault":
        case "com.amazonaws.memorydb#InvalidNodeStateFault":
            throw await deserializeAws_json1_1InvalidNodeStateFaultResponse(parsedOutput, context);
        case "InvalidParameterCombinationException":
        case "com.amazonaws.memorydb#InvalidParameterCombinationException":
            throw await deserializeAws_json1_1InvalidParameterCombinationExceptionResponse(parsedOutput, context);
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        case "InvalidVPCNetworkStateFault":
        case "com.amazonaws.memorydb#InvalidVPCNetworkStateFault":
            throw await deserializeAws_json1_1InvalidVPCNetworkStateFaultResponse(parsedOutput, context);
        case "NodeQuotaForClusterExceededFault":
        case "com.amazonaws.memorydb#NodeQuotaForClusterExceededFault":
            throw await deserializeAws_json1_1NodeQuotaForClusterExceededFaultResponse(parsedOutput, context);
        case "NodeQuotaForCustomerExceededFault":
        case "com.amazonaws.memorydb#NodeQuotaForCustomerExceededFault":
            throw await deserializeAws_json1_1NodeQuotaForCustomerExceededFaultResponse(parsedOutput, context);
        case "NoOperationFault":
        case "com.amazonaws.memorydb#NoOperationFault":
            throw await deserializeAws_json1_1NoOperationFaultResponse(parsedOutput, context);
        case "ParameterGroupNotFoundFault":
        case "com.amazonaws.memorydb#ParameterGroupNotFoundFault":
            throw await deserializeAws_json1_1ParameterGroupNotFoundFaultResponse(parsedOutput, context);
        case "ServiceLinkedRoleNotFoundFault":
        case "com.amazonaws.memorydb#ServiceLinkedRoleNotFoundFault":
            throw await deserializeAws_json1_1ServiceLinkedRoleNotFoundFaultResponse(parsedOutput, context);
        case "ShardsPerClusterQuotaExceededFault":
        case "com.amazonaws.memorydb#ShardsPerClusterQuotaExceededFault":
            throw await deserializeAws_json1_1ShardsPerClusterQuotaExceededFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1UpdateParameterGroupCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1UpdateParameterGroupCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1UpdateParameterGroupResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1UpdateParameterGroupCommand = deserializeAws_json1_1UpdateParameterGroupCommand;
const deserializeAws_json1_1UpdateParameterGroupCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidParameterCombinationException":
        case "com.amazonaws.memorydb#InvalidParameterCombinationException":
            throw await deserializeAws_json1_1InvalidParameterCombinationExceptionResponse(parsedOutput, context);
        case "InvalidParameterGroupStateFault":
        case "com.amazonaws.memorydb#InvalidParameterGroupStateFault":
            throw await deserializeAws_json1_1InvalidParameterGroupStateFaultResponse(parsedOutput, context);
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        case "ParameterGroupNotFoundFault":
        case "com.amazonaws.memorydb#ParameterGroupNotFoundFault":
            throw await deserializeAws_json1_1ParameterGroupNotFoundFaultResponse(parsedOutput, context);
        case "ServiceLinkedRoleNotFoundFault":
        case "com.amazonaws.memorydb#ServiceLinkedRoleNotFoundFault":
            throw await deserializeAws_json1_1ServiceLinkedRoleNotFoundFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1UpdateSubnetGroupCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1UpdateSubnetGroupCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1UpdateSubnetGroupResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1UpdateSubnetGroupCommand = deserializeAws_json1_1UpdateSubnetGroupCommand;
const deserializeAws_json1_1UpdateSubnetGroupCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidSubnet":
        case "com.amazonaws.memorydb#InvalidSubnet":
            throw await deserializeAws_json1_1InvalidSubnetResponse(parsedOutput, context);
        case "ServiceLinkedRoleNotFoundFault":
        case "com.amazonaws.memorydb#ServiceLinkedRoleNotFoundFault":
            throw await deserializeAws_json1_1ServiceLinkedRoleNotFoundFaultResponse(parsedOutput, context);
        case "SubnetGroupNotFoundFault":
        case "com.amazonaws.memorydb#SubnetGroupNotFoundFault":
            throw await deserializeAws_json1_1SubnetGroupNotFoundFaultResponse(parsedOutput, context);
        case "SubnetInUse":
        case "com.amazonaws.memorydb#SubnetInUse":
            throw await deserializeAws_json1_1SubnetInUseResponse(parsedOutput, context);
        case "SubnetNotAllowedFault":
        case "com.amazonaws.memorydb#SubnetNotAllowedFault":
            throw await deserializeAws_json1_1SubnetNotAllowedFaultResponse(parsedOutput, context);
        case "SubnetQuotaExceededFault":
        case "com.amazonaws.memorydb#SubnetQuotaExceededFault":
            throw await deserializeAws_json1_1SubnetQuotaExceededFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1UpdateUserCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1UpdateUserCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1UpdateUserResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_1UpdateUserCommand = deserializeAws_json1_1UpdateUserCommand;
const deserializeAws_json1_1UpdateUserCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidParameterCombinationException":
        case "com.amazonaws.memorydb#InvalidParameterCombinationException":
            throw await deserializeAws_json1_1InvalidParameterCombinationExceptionResponse(parsedOutput, context);
        case "InvalidParameterValueException":
        case "com.amazonaws.memorydb#InvalidParameterValueException":
            throw await deserializeAws_json1_1InvalidParameterValueExceptionResponse(parsedOutput, context);
        case "InvalidUserStateFault":
        case "com.amazonaws.memorydb#InvalidUserStateFault":
            throw await deserializeAws_json1_1InvalidUserStateFaultResponse(parsedOutput, context);
        case "UserNotFoundFault":
        case "com.amazonaws.memorydb#UserNotFoundFault":
            throw await deserializeAws_json1_1UserNotFoundFaultResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MemoryDBServiceException_1.MemoryDBServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_1ACLAlreadyExistsFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1ACLAlreadyExistsFault(body, context);
    const exception = new models_0_1.ACLAlreadyExistsFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1ACLNotFoundFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1ACLNotFoundFault(body, context);
    const exception = new models_0_1.ACLNotFoundFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1ACLQuotaExceededFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1ACLQuotaExceededFault(body, context);
    const exception = new models_0_1.ACLQuotaExceededFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1APICallRateForCustomerExceededFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1APICallRateForCustomerExceededFault(body, context);
    const exception = new models_0_1.APICallRateForCustomerExceededFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1ClusterAlreadyExistsFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1ClusterAlreadyExistsFault(body, context);
    const exception = new models_0_1.ClusterAlreadyExistsFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1ClusterNotFoundFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1ClusterNotFoundFault(body, context);
    const exception = new models_0_1.ClusterNotFoundFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1ClusterQuotaForCustomerExceededFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1ClusterQuotaForCustomerExceededFault(body, context);
    const exception = new models_0_1.ClusterQuotaForCustomerExceededFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1DefaultUserRequiredResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1DefaultUserRequired(body, context);
    const exception = new models_0_1.DefaultUserRequired({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1DuplicateUserNameFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1DuplicateUserNameFault(body, context);
    const exception = new models_0_1.DuplicateUserNameFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1InsufficientClusterCapacityFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1InsufficientClusterCapacityFault(body, context);
    const exception = new models_0_1.InsufficientClusterCapacityFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1InvalidACLStateFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1InvalidACLStateFault(body, context);
    const exception = new models_0_1.InvalidACLStateFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1InvalidARNFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1InvalidARNFault(body, context);
    const exception = new models_0_1.InvalidARNFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1InvalidClusterStateFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1InvalidClusterStateFault(body, context);
    const exception = new models_0_1.InvalidClusterStateFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1InvalidCredentialsExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1InvalidCredentialsException(body, context);
    const exception = new models_0_1.InvalidCredentialsException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1InvalidKMSKeyFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1InvalidKMSKeyFault(body, context);
    const exception = new models_0_1.InvalidKMSKeyFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1InvalidNodeStateFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1InvalidNodeStateFault(body, context);
    const exception = new models_0_1.InvalidNodeStateFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1InvalidParameterCombinationExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1InvalidParameterCombinationException(body, context);
    const exception = new models_0_1.InvalidParameterCombinationException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1InvalidParameterGroupStateFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1InvalidParameterGroupStateFault(body, context);
    const exception = new models_0_1.InvalidParameterGroupStateFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1InvalidParameterValueExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1InvalidParameterValueException(body, context);
    const exception = new models_0_1.InvalidParameterValueException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1InvalidSnapshotStateFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1InvalidSnapshotStateFault(body, context);
    const exception = new models_0_1.InvalidSnapshotStateFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1InvalidSubnetResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1InvalidSubnet(body, context);
    const exception = new models_0_1.InvalidSubnet({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1InvalidUserStateFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1InvalidUserStateFault(body, context);
    const exception = new models_0_1.InvalidUserStateFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1InvalidVPCNetworkStateFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1InvalidVPCNetworkStateFault(body, context);
    const exception = new models_0_1.InvalidVPCNetworkStateFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1NodeQuotaForClusterExceededFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1NodeQuotaForClusterExceededFault(body, context);
    const exception = new models_0_1.NodeQuotaForClusterExceededFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1NodeQuotaForCustomerExceededFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1NodeQuotaForCustomerExceededFault(body, context);
    const exception = new models_0_1.NodeQuotaForCustomerExceededFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1NoOperationFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1NoOperationFault(body, context);
    const exception = new models_0_1.NoOperationFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1ParameterGroupAlreadyExistsFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1ParameterGroupAlreadyExistsFault(body, context);
    const exception = new models_0_1.ParameterGroupAlreadyExistsFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1ParameterGroupNotFoundFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1ParameterGroupNotFoundFault(body, context);
    const exception = new models_0_1.ParameterGroupNotFoundFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1ParameterGroupQuotaExceededFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1ParameterGroupQuotaExceededFault(body, context);
    const exception = new models_0_1.ParameterGroupQuotaExceededFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1ServiceLinkedRoleNotFoundFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1ServiceLinkedRoleNotFoundFault(body, context);
    const exception = new models_0_1.ServiceLinkedRoleNotFoundFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1ServiceUpdateNotFoundFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1ServiceUpdateNotFoundFault(body, context);
    const exception = new models_0_1.ServiceUpdateNotFoundFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1ShardNotFoundFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1ShardNotFoundFault(body, context);
    const exception = new models_0_1.ShardNotFoundFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1ShardsPerClusterQuotaExceededFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1ShardsPerClusterQuotaExceededFault(body, context);
    const exception = new models_0_1.ShardsPerClusterQuotaExceededFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1SnapshotAlreadyExistsFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1SnapshotAlreadyExistsFault(body, context);
    const exception = new models_0_1.SnapshotAlreadyExistsFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1SnapshotNotFoundFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1SnapshotNotFoundFault(body, context);
    const exception = new models_0_1.SnapshotNotFoundFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1SnapshotQuotaExceededFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1SnapshotQuotaExceededFault(body, context);
    const exception = new models_0_1.SnapshotQuotaExceededFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1SubnetGroupAlreadyExistsFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1SubnetGroupAlreadyExistsFault(body, context);
    const exception = new models_0_1.SubnetGroupAlreadyExistsFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1SubnetGroupInUseFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1SubnetGroupInUseFault(body, context);
    const exception = new models_0_1.SubnetGroupInUseFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1SubnetGroupNotFoundFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1SubnetGroupNotFoundFault(body, context);
    const exception = new models_0_1.SubnetGroupNotFoundFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1SubnetGroupQuotaExceededFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1SubnetGroupQuotaExceededFault(body, context);
    const exception = new models_0_1.SubnetGroupQuotaExceededFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1SubnetInUseResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1SubnetInUse(body, context);
    const exception = new models_0_1.SubnetInUse({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1SubnetNotAllowedFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1SubnetNotAllowedFault(body, context);
    const exception = new models_0_1.SubnetNotAllowedFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1SubnetQuotaExceededFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1SubnetQuotaExceededFault(body, context);
    const exception = new models_0_1.SubnetQuotaExceededFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1TagNotFoundFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1TagNotFoundFault(body, context);
    const exception = new models_0_1.TagNotFoundFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1TagQuotaPerResourceExceededResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1TagQuotaPerResourceExceeded(body, context);
    const exception = new models_0_1.TagQuotaPerResourceExceeded({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1TestFailoverNotAvailableFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1TestFailoverNotAvailableFault(body, context);
    const exception = new models_0_1.TestFailoverNotAvailableFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1UserAlreadyExistsFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1UserAlreadyExistsFault(body, context);
    const exception = new models_0_1.UserAlreadyExistsFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1UserNotFoundFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1UserNotFoundFault(body, context);
    const exception = new models_0_1.UserNotFoundFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_1UserQuotaExceededFaultResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1UserQuotaExceededFault(body, context);
    const exception = new models_0_1.UserQuotaExceededFault({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const serializeAws_json1_1AuthenticationMode = (input, context) => {
    return {
        ...(input.Passwords !== undefined &&
            input.Passwords !== null && { Passwords: serializeAws_json1_1PasswordListInput(input.Passwords, context) }),
        ...(input.Type !== undefined && input.Type !== null && { Type: input.Type }),
    };
};
const serializeAws_json1_1BatchUpdateClusterRequest = (input, context) => {
    return {
        ...(input.ClusterNames !== undefined &&
            input.ClusterNames !== null && {
            ClusterNames: serializeAws_json1_1ClusterNameList(input.ClusterNames, context),
        }),
        ...(input.ServiceUpdate !== undefined &&
            input.ServiceUpdate !== null && {
            ServiceUpdate: serializeAws_json1_1ServiceUpdateRequest(input.ServiceUpdate, context),
        }),
    };
};
const serializeAws_json1_1ClusterNameList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_json1_1CopySnapshotRequest = (input, context) => {
    return {
        ...(input.KmsKeyId !== undefined && input.KmsKeyId !== null && { KmsKeyId: input.KmsKeyId }),
        ...(input.SourceSnapshotName !== undefined &&
            input.SourceSnapshotName !== null && { SourceSnapshotName: input.SourceSnapshotName }),
        ...(input.Tags !== undefined && input.Tags !== null && { Tags: serializeAws_json1_1TagList(input.Tags, context) }),
        ...(input.TargetBucket !== undefined && input.TargetBucket !== null && { TargetBucket: input.TargetBucket }),
        ...(input.TargetSnapshotName !== undefined &&
            input.TargetSnapshotName !== null && { TargetSnapshotName: input.TargetSnapshotName }),
    };
};
const serializeAws_json1_1CreateACLRequest = (input, context) => {
    return {
        ...(input.ACLName !== undefined && input.ACLName !== null && { ACLName: input.ACLName }),
        ...(input.Tags !== undefined && input.Tags !== null && { Tags: serializeAws_json1_1TagList(input.Tags, context) }),
        ...(input.UserNames !== undefined &&
            input.UserNames !== null && { UserNames: serializeAws_json1_1UserNameListInput(input.UserNames, context) }),
    };
};
const serializeAws_json1_1CreateClusterRequest = (input, context) => {
    return {
        ...(input.ACLName !== undefined && input.ACLName !== null && { ACLName: input.ACLName }),
        ...(input.AutoMinorVersionUpgrade !== undefined &&
            input.AutoMinorVersionUpgrade !== null && { AutoMinorVersionUpgrade: input.AutoMinorVersionUpgrade }),
        ...(input.ClusterName !== undefined && input.ClusterName !== null && { ClusterName: input.ClusterName }),
        ...(input.Description !== undefined && input.Description !== null && { Description: input.Description }),
        ...(input.EngineVersion !== undefined && input.EngineVersion !== null && { EngineVersion: input.EngineVersion }),
        ...(input.KmsKeyId !== undefined && input.KmsKeyId !== null && { KmsKeyId: input.KmsKeyId }),
        ...(input.MaintenanceWindow !== undefined &&
            input.MaintenanceWindow !== null && { MaintenanceWindow: input.MaintenanceWindow }),
        ...(input.NodeType !== undefined && input.NodeType !== null && { NodeType: input.NodeType }),
        ...(input.NumReplicasPerShard !== undefined &&
            input.NumReplicasPerShard !== null && { NumReplicasPerShard: input.NumReplicasPerShard }),
        ...(input.NumShards !== undefined && input.NumShards !== null && { NumShards: input.NumShards }),
        ...(input.ParameterGroupName !== undefined &&
            input.ParameterGroupName !== null && { ParameterGroupName: input.ParameterGroupName }),
        ...(input.Port !== undefined && input.Port !== null && { Port: input.Port }),
        ...(input.SecurityGroupIds !== undefined &&
            input.SecurityGroupIds !== null && {
            SecurityGroupIds: serializeAws_json1_1SecurityGroupIdsList(input.SecurityGroupIds, context),
        }),
        ...(input.SnapshotArns !== undefined &&
            input.SnapshotArns !== null && {
            SnapshotArns: serializeAws_json1_1SnapshotArnsList(input.SnapshotArns, context),
        }),
        ...(input.SnapshotName !== undefined && input.SnapshotName !== null && { SnapshotName: input.SnapshotName }),
        ...(input.SnapshotRetentionLimit !== undefined &&
            input.SnapshotRetentionLimit !== null && { SnapshotRetentionLimit: input.SnapshotRetentionLimit }),
        ...(input.SnapshotWindow !== undefined &&
            input.SnapshotWindow !== null && { SnapshotWindow: input.SnapshotWindow }),
        ...(input.SnsTopicArn !== undefined && input.SnsTopicArn !== null && { SnsTopicArn: input.SnsTopicArn }),
        ...(input.SubnetGroupName !== undefined &&
            input.SubnetGroupName !== null && { SubnetGroupName: input.SubnetGroupName }),
        ...(input.TLSEnabled !== undefined && input.TLSEnabled !== null && { TLSEnabled: input.TLSEnabled }),
        ...(input.Tags !== undefined && input.Tags !== null && { Tags: serializeAws_json1_1TagList(input.Tags, context) }),
    };
};
const serializeAws_json1_1CreateParameterGroupRequest = (input, context) => {
    return {
        ...(input.Description !== undefined && input.Description !== null && { Description: input.Description }),
        ...(input.Family !== undefined && input.Family !== null && { Family: input.Family }),
        ...(input.ParameterGroupName !== undefined &&
            input.ParameterGroupName !== null && { ParameterGroupName: input.ParameterGroupName }),
        ...(input.Tags !== undefined && input.Tags !== null && { Tags: serializeAws_json1_1TagList(input.Tags, context) }),
    };
};
const serializeAws_json1_1CreateSnapshotRequest = (input, context) => {
    return {
        ...(input.ClusterName !== undefined && input.ClusterName !== null && { ClusterName: input.ClusterName }),
        ...(input.KmsKeyId !== undefined && input.KmsKeyId !== null && { KmsKeyId: input.KmsKeyId }),
        ...(input.SnapshotName !== undefined && input.SnapshotName !== null && { SnapshotName: input.SnapshotName }),
        ...(input.Tags !== undefined && input.Tags !== null && { Tags: serializeAws_json1_1TagList(input.Tags, context) }),
    };
};
const serializeAws_json1_1CreateSubnetGroupRequest = (input, context) => {
    return {
        ...(input.Description !== undefined && input.Description !== null && { Description: input.Description }),
        ...(input.SubnetGroupName !== undefined &&
            input.SubnetGroupName !== null && { SubnetGroupName: input.SubnetGroupName }),
        ...(input.SubnetIds !== undefined &&
            input.SubnetIds !== null && { SubnetIds: serializeAws_json1_1SubnetIdentifierList(input.SubnetIds, context) }),
        ...(input.Tags !== undefined && input.Tags !== null && { Tags: serializeAws_json1_1TagList(input.Tags, context) }),
    };
};
const serializeAws_json1_1CreateUserRequest = (input, context) => {
    return {
        ...(input.AccessString !== undefined && input.AccessString !== null && { AccessString: input.AccessString }),
        ...(input.AuthenticationMode !== undefined &&
            input.AuthenticationMode !== null && {
            AuthenticationMode: serializeAws_json1_1AuthenticationMode(input.AuthenticationMode, context),
        }),
        ...(input.Tags !== undefined && input.Tags !== null && { Tags: serializeAws_json1_1TagList(input.Tags, context) }),
        ...(input.UserName !== undefined && input.UserName !== null && { UserName: input.UserName }),
    };
};
const serializeAws_json1_1DeleteACLRequest = (input, context) => {
    return {
        ...(input.ACLName !== undefined && input.ACLName !== null && { ACLName: input.ACLName }),
    };
};
const serializeAws_json1_1DeleteClusterRequest = (input, context) => {
    return {
        ...(input.ClusterName !== undefined && input.ClusterName !== null && { ClusterName: input.ClusterName }),
        ...(input.FinalSnapshotName !== undefined &&
            input.FinalSnapshotName !== null && { FinalSnapshotName: input.FinalSnapshotName }),
    };
};
const serializeAws_json1_1DeleteParameterGroupRequest = (input, context) => {
    return {
        ...(input.ParameterGroupName !== undefined &&
            input.ParameterGroupName !== null && { ParameterGroupName: input.ParameterGroupName }),
    };
};
const serializeAws_json1_1DeleteSnapshotRequest = (input, context) => {
    return {
        ...(input.SnapshotName !== undefined && input.SnapshotName !== null && { SnapshotName: input.SnapshotName }),
    };
};
const serializeAws_json1_1DeleteSubnetGroupRequest = (input, context) => {
    return {
        ...(input.SubnetGroupName !== undefined &&
            input.SubnetGroupName !== null && { SubnetGroupName: input.SubnetGroupName }),
    };
};
const serializeAws_json1_1DeleteUserRequest = (input, context) => {
    return {
        ...(input.UserName !== undefined && input.UserName !== null && { UserName: input.UserName }),
    };
};
const serializeAws_json1_1DescribeACLsRequest = (input, context) => {
    return {
        ...(input.ACLName !== undefined && input.ACLName !== null && { ACLName: input.ACLName }),
        ...(input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults }),
        ...(input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }),
    };
};
const serializeAws_json1_1DescribeClustersRequest = (input, context) => {
    return {
        ...(input.ClusterName !== undefined && input.ClusterName !== null && { ClusterName: input.ClusterName }),
        ...(input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults }),
        ...(input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }),
        ...(input.ShowShardDetails !== undefined &&
            input.ShowShardDetails !== null && { ShowShardDetails: input.ShowShardDetails }),
    };
};
const serializeAws_json1_1DescribeEngineVersionsRequest = (input, context) => {
    return {
        ...(input.DefaultOnly !== undefined && input.DefaultOnly !== null && { DefaultOnly: input.DefaultOnly }),
        ...(input.EngineVersion !== undefined && input.EngineVersion !== null && { EngineVersion: input.EngineVersion }),
        ...(input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults }),
        ...(input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }),
        ...(input.ParameterGroupFamily !== undefined &&
            input.ParameterGroupFamily !== null && { ParameterGroupFamily: input.ParameterGroupFamily }),
    };
};
const serializeAws_json1_1DescribeEventsRequest = (input, context) => {
    return {
        ...(input.Duration !== undefined && input.Duration !== null && { Duration: input.Duration }),
        ...(input.EndTime !== undefined &&
            input.EndTime !== null && { EndTime: Math.round(input.EndTime.getTime() / 1000) }),
        ...(input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults }),
        ...(input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }),
        ...(input.SourceName !== undefined && input.SourceName !== null && { SourceName: input.SourceName }),
        ...(input.SourceType !== undefined && input.SourceType !== null && { SourceType: input.SourceType }),
        ...(input.StartTime !== undefined &&
            input.StartTime !== null && { StartTime: Math.round(input.StartTime.getTime() / 1000) }),
    };
};
const serializeAws_json1_1DescribeParameterGroupsRequest = (input, context) => {
    return {
        ...(input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults }),
        ...(input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }),
        ...(input.ParameterGroupName !== undefined &&
            input.ParameterGroupName !== null && { ParameterGroupName: input.ParameterGroupName }),
    };
};
const serializeAws_json1_1DescribeParametersRequest = (input, context) => {
    return {
        ...(input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults }),
        ...(input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }),
        ...(input.ParameterGroupName !== undefined &&
            input.ParameterGroupName !== null && { ParameterGroupName: input.ParameterGroupName }),
    };
};
const serializeAws_json1_1DescribeServiceUpdatesRequest = (input, context) => {
    return {
        ...(input.ClusterNames !== undefined &&
            input.ClusterNames !== null && {
            ClusterNames: serializeAws_json1_1ClusterNameList(input.ClusterNames, context),
        }),
        ...(input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults }),
        ...(input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }),
        ...(input.ServiceUpdateName !== undefined &&
            input.ServiceUpdateName !== null && { ServiceUpdateName: input.ServiceUpdateName }),
        ...(input.Status !== undefined &&
            input.Status !== null && { Status: serializeAws_json1_1ServiceUpdateStatusList(input.Status, context) }),
    };
};
const serializeAws_json1_1DescribeSnapshotsRequest = (input, context) => {
    return {
        ...(input.ClusterName !== undefined && input.ClusterName !== null && { ClusterName: input.ClusterName }),
        ...(input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults }),
        ...(input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }),
        ...(input.ShowDetail !== undefined && input.ShowDetail !== null && { ShowDetail: input.ShowDetail }),
        ...(input.SnapshotName !== undefined && input.SnapshotName !== null && { SnapshotName: input.SnapshotName }),
        ...(input.Source !== undefined && input.Source !== null && { Source: input.Source }),
    };
};
const serializeAws_json1_1DescribeSubnetGroupsRequest = (input, context) => {
    return {
        ...(input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults }),
        ...(input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }),
        ...(input.SubnetGroupName !== undefined &&
            input.SubnetGroupName !== null && { SubnetGroupName: input.SubnetGroupName }),
    };
};
const serializeAws_json1_1DescribeUsersRequest = (input, context) => {
    return {
        ...(input.Filters !== undefined &&
            input.Filters !== null && { Filters: serializeAws_json1_1FilterList(input.Filters, context) }),
        ...(input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults }),
        ...(input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }),
        ...(input.UserName !== undefined && input.UserName !== null && { UserName: input.UserName }),
    };
};
const serializeAws_json1_1FailoverShardRequest = (input, context) => {
    return {
        ...(input.ClusterName !== undefined && input.ClusterName !== null && { ClusterName: input.ClusterName }),
        ...(input.ShardName !== undefined && input.ShardName !== null && { ShardName: input.ShardName }),
    };
};
const serializeAws_json1_1Filter = (input, context) => {
    return {
        ...(input.Name !== undefined && input.Name !== null && { Name: input.Name }),
        ...(input.Values !== undefined &&
            input.Values !== null && { Values: serializeAws_json1_1FilterValueList(input.Values, context) }),
    };
};
const serializeAws_json1_1FilterList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return serializeAws_json1_1Filter(entry, context);
    });
};
const serializeAws_json1_1FilterValueList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_json1_1KeyList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_json1_1ListAllowedNodeTypeUpdatesRequest = (input, context) => {
    return {
        ...(input.ClusterName !== undefined && input.ClusterName !== null && { ClusterName: input.ClusterName }),
    };
};
const serializeAws_json1_1ListTagsRequest = (input, context) => {
    return {
        ...(input.ResourceArn !== undefined && input.ResourceArn !== null && { ResourceArn: input.ResourceArn }),
    };
};
const serializeAws_json1_1ParameterNameList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_json1_1ParameterNameValue = (input, context) => {
    return {
        ...(input.ParameterName !== undefined && input.ParameterName !== null && { ParameterName: input.ParameterName }),
        ...(input.ParameterValue !== undefined &&
            input.ParameterValue !== null && { ParameterValue: input.ParameterValue }),
    };
};
const serializeAws_json1_1ParameterNameValueList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return serializeAws_json1_1ParameterNameValue(entry, context);
    });
};
const serializeAws_json1_1PasswordListInput = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_json1_1ReplicaConfigurationRequest = (input, context) => {
    return {
        ...(input.ReplicaCount !== undefined && input.ReplicaCount !== null && { ReplicaCount: input.ReplicaCount }),
    };
};
const serializeAws_json1_1ResetParameterGroupRequest = (input, context) => {
    return {
        ...(input.AllParameters !== undefined && input.AllParameters !== null && { AllParameters: input.AllParameters }),
        ...(input.ParameterGroupName !== undefined &&
            input.ParameterGroupName !== null && { ParameterGroupName: input.ParameterGroupName }),
        ...(input.ParameterNames !== undefined &&
            input.ParameterNames !== null && {
            ParameterNames: serializeAws_json1_1ParameterNameList(input.ParameterNames, context),
        }),
    };
};
const serializeAws_json1_1SecurityGroupIdsList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_json1_1ServiceUpdateRequest = (input, context) => {
    return {
        ...(input.ServiceUpdateNameToApply !== undefined &&
            input.ServiceUpdateNameToApply !== null && { ServiceUpdateNameToApply: input.ServiceUpdateNameToApply }),
    };
};
const serializeAws_json1_1ServiceUpdateStatusList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_json1_1ShardConfigurationRequest = (input, context) => {
    return {
        ...(input.ShardCount !== undefined && input.ShardCount !== null && { ShardCount: input.ShardCount }),
    };
};
const serializeAws_json1_1SnapshotArnsList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_json1_1SubnetIdentifierList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_json1_1Tag = (input, context) => {
    return {
        ...(input.Key !== undefined && input.Key !== null && { Key: input.Key }),
        ...(input.Value !== undefined && input.Value !== null && { Value: input.Value }),
    };
};
const serializeAws_json1_1TagList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return serializeAws_json1_1Tag(entry, context);
    });
};
const serializeAws_json1_1TagResourceRequest = (input, context) => {
    return {
        ...(input.ResourceArn !== undefined && input.ResourceArn !== null && { ResourceArn: input.ResourceArn }),
        ...(input.Tags !== undefined && input.Tags !== null && { Tags: serializeAws_json1_1TagList(input.Tags, context) }),
    };
};
const serializeAws_json1_1UntagResourceRequest = (input, context) => {
    return {
        ...(input.ResourceArn !== undefined && input.ResourceArn !== null && { ResourceArn: input.ResourceArn }),
        ...(input.TagKeys !== undefined &&
            input.TagKeys !== null && { TagKeys: serializeAws_json1_1KeyList(input.TagKeys, context) }),
    };
};
const serializeAws_json1_1UpdateACLRequest = (input, context) => {
    return {
        ...(input.ACLName !== undefined && input.ACLName !== null && { ACLName: input.ACLName }),
        ...(input.UserNamesToAdd !== undefined &&
            input.UserNamesToAdd !== null && {
            UserNamesToAdd: serializeAws_json1_1UserNameListInput(input.UserNamesToAdd, context),
        }),
        ...(input.UserNamesToRemove !== undefined &&
            input.UserNamesToRemove !== null && {
            UserNamesToRemove: serializeAws_json1_1UserNameListInput(input.UserNamesToRemove, context),
        }),
    };
};
const serializeAws_json1_1UpdateClusterRequest = (input, context) => {
    return {
        ...(input.ACLName !== undefined && input.ACLName !== null && { ACLName: input.ACLName }),
        ...(input.ClusterName !== undefined && input.ClusterName !== null && { ClusterName: input.ClusterName }),
        ...(input.Description !== undefined && input.Description !== null && { Description: input.Description }),
        ...(input.EngineVersion !== undefined && input.EngineVersion !== null && { EngineVersion: input.EngineVersion }),
        ...(input.MaintenanceWindow !== undefined &&
            input.MaintenanceWindow !== null && { MaintenanceWindow: input.MaintenanceWindow }),
        ...(input.NodeType !== undefined && input.NodeType !== null && { NodeType: input.NodeType }),
        ...(input.ParameterGroupName !== undefined &&
            input.ParameterGroupName !== null && { ParameterGroupName: input.ParameterGroupName }),
        ...(input.ReplicaConfiguration !== undefined &&
            input.ReplicaConfiguration !== null && {
            ReplicaConfiguration: serializeAws_json1_1ReplicaConfigurationRequest(input.ReplicaConfiguration, context),
        }),
        ...(input.SecurityGroupIds !== undefined &&
            input.SecurityGroupIds !== null && {
            SecurityGroupIds: serializeAws_json1_1SecurityGroupIdsList(input.SecurityGroupIds, context),
        }),
        ...(input.ShardConfiguration !== undefined &&
            input.ShardConfiguration !== null && {
            ShardConfiguration: serializeAws_json1_1ShardConfigurationRequest(input.ShardConfiguration, context),
        }),
        ...(input.SnapshotRetentionLimit !== undefined &&
            input.SnapshotRetentionLimit !== null && { SnapshotRetentionLimit: input.SnapshotRetentionLimit }),
        ...(input.SnapshotWindow !== undefined &&
            input.SnapshotWindow !== null && { SnapshotWindow: input.SnapshotWindow }),
        ...(input.SnsTopicArn !== undefined && input.SnsTopicArn !== null && { SnsTopicArn: input.SnsTopicArn }),
        ...(input.SnsTopicStatus !== undefined &&
            input.SnsTopicStatus !== null && { SnsTopicStatus: input.SnsTopicStatus }),
    };
};
const serializeAws_json1_1UpdateParameterGroupRequest = (input, context) => {
    return {
        ...(input.ParameterGroupName !== undefined &&
            input.ParameterGroupName !== null && { ParameterGroupName: input.ParameterGroupName }),
        ...(input.ParameterNameValues !== undefined &&
            input.ParameterNameValues !== null && {
            ParameterNameValues: serializeAws_json1_1ParameterNameValueList(input.ParameterNameValues, context),
        }),
    };
};
const serializeAws_json1_1UpdateSubnetGroupRequest = (input, context) => {
    return {
        ...(input.Description !== undefined && input.Description !== null && { Description: input.Description }),
        ...(input.SubnetGroupName !== undefined &&
            input.SubnetGroupName !== null && { SubnetGroupName: input.SubnetGroupName }),
        ...(input.SubnetIds !== undefined &&
            input.SubnetIds !== null && { SubnetIds: serializeAws_json1_1SubnetIdentifierList(input.SubnetIds, context) }),
    };
};
const serializeAws_json1_1UpdateUserRequest = (input, context) => {
    return {
        ...(input.AccessString !== undefined && input.AccessString !== null && { AccessString: input.AccessString }),
        ...(input.AuthenticationMode !== undefined &&
            input.AuthenticationMode !== null && {
            AuthenticationMode: serializeAws_json1_1AuthenticationMode(input.AuthenticationMode, context),
        }),
        ...(input.UserName !== undefined && input.UserName !== null && { UserName: input.UserName }),
    };
};
const serializeAws_json1_1UserNameListInput = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const deserializeAws_json1_1ACL = (output, context) => {
    return {
        ARN: (0, smithy_client_1.expectString)(output.ARN),
        Clusters: output.Clusters !== undefined && output.Clusters !== null
            ? deserializeAws_json1_1ACLClusterNameList(output.Clusters, context)
            : undefined,
        MinimumEngineVersion: (0, smithy_client_1.expectString)(output.MinimumEngineVersion),
        Name: (0, smithy_client_1.expectString)(output.Name),
        PendingChanges: output.PendingChanges !== undefined && output.PendingChanges !== null
            ? deserializeAws_json1_1ACLPendingChanges(output.PendingChanges, context)
            : undefined,
        Status: (0, smithy_client_1.expectString)(output.Status),
        UserNames: output.UserNames !== undefined && output.UserNames !== null
            ? deserializeAws_json1_1UserNameList(output.UserNames, context)
            : undefined,
    };
};
const deserializeAws_json1_1ACLAlreadyExistsFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1ACLClusterNameList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return (0, smithy_client_1.expectString)(entry);
    });
    return retVal;
};
const deserializeAws_json1_1ACLList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1ACL(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1ACLNameList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return (0, smithy_client_1.expectString)(entry);
    });
    return retVal;
};
const deserializeAws_json1_1ACLNotFoundFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1ACLPendingChanges = (output, context) => {
    return {
        UserNamesToAdd: output.UserNamesToAdd !== undefined && output.UserNamesToAdd !== null
            ? deserializeAws_json1_1UserNameList(output.UserNamesToAdd, context)
            : undefined,
        UserNamesToRemove: output.UserNamesToRemove !== undefined && output.UserNamesToRemove !== null
            ? deserializeAws_json1_1UserNameList(output.UserNamesToRemove, context)
            : undefined,
    };
};
const deserializeAws_json1_1ACLQuotaExceededFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1ACLsUpdateStatus = (output, context) => {
    return {
        ACLToApply: (0, smithy_client_1.expectString)(output.ACLToApply),
    };
};
const deserializeAws_json1_1APICallRateForCustomerExceededFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1Authentication = (output, context) => {
    return {
        PasswordCount: (0, smithy_client_1.expectInt32)(output.PasswordCount),
        Type: (0, smithy_client_1.expectString)(output.Type),
    };
};
const deserializeAws_json1_1AvailabilityZone = (output, context) => {
    return {
        Name: (0, smithy_client_1.expectString)(output.Name),
    };
};
const deserializeAws_json1_1BatchUpdateClusterResponse = (output, context) => {
    return {
        ProcessedClusters: output.ProcessedClusters !== undefined && output.ProcessedClusters !== null
            ? deserializeAws_json1_1ClusterList(output.ProcessedClusters, context)
            : undefined,
        UnprocessedClusters: output.UnprocessedClusters !== undefined && output.UnprocessedClusters !== null
            ? deserializeAws_json1_1UnprocessedClusterList(output.UnprocessedClusters, context)
            : undefined,
    };
};
const deserializeAws_json1_1Cluster = (output, context) => {
    return {
        ACLName: (0, smithy_client_1.expectString)(output.ACLName),
        ARN: (0, smithy_client_1.expectString)(output.ARN),
        AutoMinorVersionUpgrade: (0, smithy_client_1.expectBoolean)(output.AutoMinorVersionUpgrade),
        AvailabilityMode: (0, smithy_client_1.expectString)(output.AvailabilityMode),
        ClusterEndpoint: output.ClusterEndpoint !== undefined && output.ClusterEndpoint !== null
            ? deserializeAws_json1_1Endpoint(output.ClusterEndpoint, context)
            : undefined,
        Description: (0, smithy_client_1.expectString)(output.Description),
        EnginePatchVersion: (0, smithy_client_1.expectString)(output.EnginePatchVersion),
        EngineVersion: (0, smithy_client_1.expectString)(output.EngineVersion),
        KmsKeyId: (0, smithy_client_1.expectString)(output.KmsKeyId),
        MaintenanceWindow: (0, smithy_client_1.expectString)(output.MaintenanceWindow),
        Name: (0, smithy_client_1.expectString)(output.Name),
        NodeType: (0, smithy_client_1.expectString)(output.NodeType),
        NumberOfShards: (0, smithy_client_1.expectInt32)(output.NumberOfShards),
        ParameterGroupName: (0, smithy_client_1.expectString)(output.ParameterGroupName),
        ParameterGroupStatus: (0, smithy_client_1.expectString)(output.ParameterGroupStatus),
        PendingUpdates: output.PendingUpdates !== undefined && output.PendingUpdates !== null
            ? deserializeAws_json1_1ClusterPendingUpdates(output.PendingUpdates, context)
            : undefined,
        SecurityGroups: output.SecurityGroups !== undefined && output.SecurityGroups !== null
            ? deserializeAws_json1_1SecurityGroupMembershipList(output.SecurityGroups, context)
            : undefined,
        Shards: output.Shards !== undefined && output.Shards !== null
            ? deserializeAws_json1_1ShardList(output.Shards, context)
            : undefined,
        SnapshotRetentionLimit: (0, smithy_client_1.expectInt32)(output.SnapshotRetentionLimit),
        SnapshotWindow: (0, smithy_client_1.expectString)(output.SnapshotWindow),
        SnsTopicArn: (0, smithy_client_1.expectString)(output.SnsTopicArn),
        SnsTopicStatus: (0, smithy_client_1.expectString)(output.SnsTopicStatus),
        Status: (0, smithy_client_1.expectString)(output.Status),
        SubnetGroupName: (0, smithy_client_1.expectString)(output.SubnetGroupName),
        TLSEnabled: (0, smithy_client_1.expectBoolean)(output.TLSEnabled),
    };
};
const deserializeAws_json1_1ClusterAlreadyExistsFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1ClusterConfiguration = (output, context) => {
    return {
        Description: (0, smithy_client_1.expectString)(output.Description),
        EngineVersion: (0, smithy_client_1.expectString)(output.EngineVersion),
        MaintenanceWindow: (0, smithy_client_1.expectString)(output.MaintenanceWindow),
        Name: (0, smithy_client_1.expectString)(output.Name),
        NodeType: (0, smithy_client_1.expectString)(output.NodeType),
        NumShards: (0, smithy_client_1.expectInt32)(output.NumShards),
        ParameterGroupName: (0, smithy_client_1.expectString)(output.ParameterGroupName),
        Port: (0, smithy_client_1.expectInt32)(output.Port),
        Shards: output.Shards !== undefined && output.Shards !== null
            ? deserializeAws_json1_1ShardDetails(output.Shards, context)
            : undefined,
        SnapshotRetentionLimit: (0, smithy_client_1.expectInt32)(output.SnapshotRetentionLimit),
        SnapshotWindow: (0, smithy_client_1.expectString)(output.SnapshotWindow),
        SubnetGroupName: (0, smithy_client_1.expectString)(output.SubnetGroupName),
        TopicArn: (0, smithy_client_1.expectString)(output.TopicArn),
        VpcId: (0, smithy_client_1.expectString)(output.VpcId),
    };
};
const deserializeAws_json1_1ClusterList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1Cluster(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1ClusterNotFoundFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1ClusterPendingUpdates = (output, context) => {
    return {
        ACLs: output.ACLs !== undefined && output.ACLs !== null
            ? deserializeAws_json1_1ACLsUpdateStatus(output.ACLs, context)
            : undefined,
        Resharding: output.Resharding !== undefined && output.Resharding !== null
            ? deserializeAws_json1_1ReshardingStatus(output.Resharding, context)
            : undefined,
        ServiceUpdates: output.ServiceUpdates !== undefined && output.ServiceUpdates !== null
            ? deserializeAws_json1_1PendingModifiedServiceUpdateList(output.ServiceUpdates, context)
            : undefined,
    };
};
const deserializeAws_json1_1ClusterQuotaForCustomerExceededFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1CopySnapshotResponse = (output, context) => {
    return {
        Snapshot: output.Snapshot !== undefined && output.Snapshot !== null
            ? deserializeAws_json1_1Snapshot(output.Snapshot, context)
            : undefined,
    };
};
const deserializeAws_json1_1CreateACLResponse = (output, context) => {
    return {
        ACL: output.ACL !== undefined && output.ACL !== null ? deserializeAws_json1_1ACL(output.ACL, context) : undefined,
    };
};
const deserializeAws_json1_1CreateClusterResponse = (output, context) => {
    return {
        Cluster: output.Cluster !== undefined && output.Cluster !== null
            ? deserializeAws_json1_1Cluster(output.Cluster, context)
            : undefined,
    };
};
const deserializeAws_json1_1CreateParameterGroupResponse = (output, context) => {
    return {
        ParameterGroup: output.ParameterGroup !== undefined && output.ParameterGroup !== null
            ? deserializeAws_json1_1ParameterGroup(output.ParameterGroup, context)
            : undefined,
    };
};
const deserializeAws_json1_1CreateSnapshotResponse = (output, context) => {
    return {
        Snapshot: output.Snapshot !== undefined && output.Snapshot !== null
            ? deserializeAws_json1_1Snapshot(output.Snapshot, context)
            : undefined,
    };
};
const deserializeAws_json1_1CreateSubnetGroupResponse = (output, context) => {
    return {
        SubnetGroup: output.SubnetGroup !== undefined && output.SubnetGroup !== null
            ? deserializeAws_json1_1SubnetGroup(output.SubnetGroup, context)
            : undefined,
    };
};
const deserializeAws_json1_1CreateUserResponse = (output, context) => {
    return {
        User: output.User !== undefined && output.User !== null ? deserializeAws_json1_1User(output.User, context) : undefined,
    };
};
const deserializeAws_json1_1DefaultUserRequired = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1DeleteACLResponse = (output, context) => {
    return {
        ACL: output.ACL !== undefined && output.ACL !== null ? deserializeAws_json1_1ACL(output.ACL, context) : undefined,
    };
};
const deserializeAws_json1_1DeleteClusterResponse = (output, context) => {
    return {
        Cluster: output.Cluster !== undefined && output.Cluster !== null
            ? deserializeAws_json1_1Cluster(output.Cluster, context)
            : undefined,
    };
};
const deserializeAws_json1_1DeleteParameterGroupResponse = (output, context) => {
    return {
        ParameterGroup: output.ParameterGroup !== undefined && output.ParameterGroup !== null
            ? deserializeAws_json1_1ParameterGroup(output.ParameterGroup, context)
            : undefined,
    };
};
const deserializeAws_json1_1DeleteSnapshotResponse = (output, context) => {
    return {
        Snapshot: output.Snapshot !== undefined && output.Snapshot !== null
            ? deserializeAws_json1_1Snapshot(output.Snapshot, context)
            : undefined,
    };
};
const deserializeAws_json1_1DeleteSubnetGroupResponse = (output, context) => {
    return {
        SubnetGroup: output.SubnetGroup !== undefined && output.SubnetGroup !== null
            ? deserializeAws_json1_1SubnetGroup(output.SubnetGroup, context)
            : undefined,
    };
};
const deserializeAws_json1_1DeleteUserResponse = (output, context) => {
    return {
        User: output.User !== undefined && output.User !== null ? deserializeAws_json1_1User(output.User, context) : undefined,
    };
};
const deserializeAws_json1_1DescribeACLsResponse = (output, context) => {
    return {
        ACLs: output.ACLs !== undefined && output.ACLs !== null
            ? deserializeAws_json1_1ACLList(output.ACLs, context)
            : undefined,
        NextToken: (0, smithy_client_1.expectString)(output.NextToken),
    };
};
const deserializeAws_json1_1DescribeClustersResponse = (output, context) => {
    return {
        Clusters: output.Clusters !== undefined && output.Clusters !== null
            ? deserializeAws_json1_1ClusterList(output.Clusters, context)
            : undefined,
        NextToken: (0, smithy_client_1.expectString)(output.NextToken),
    };
};
const deserializeAws_json1_1DescribeEngineVersionsResponse = (output, context) => {
    return {
        EngineVersions: output.EngineVersions !== undefined && output.EngineVersions !== null
            ? deserializeAws_json1_1EngineVersionInfoList(output.EngineVersions, context)
            : undefined,
        NextToken: (0, smithy_client_1.expectString)(output.NextToken),
    };
};
const deserializeAws_json1_1DescribeEventsResponse = (output, context) => {
    return {
        Events: output.Events !== undefined && output.Events !== null
            ? deserializeAws_json1_1EventList(output.Events, context)
            : undefined,
        NextToken: (0, smithy_client_1.expectString)(output.NextToken),
    };
};
const deserializeAws_json1_1DescribeParameterGroupsResponse = (output, context) => {
    return {
        NextToken: (0, smithy_client_1.expectString)(output.NextToken),
        ParameterGroups: output.ParameterGroups !== undefined && output.ParameterGroups !== null
            ? deserializeAws_json1_1ParameterGroupList(output.ParameterGroups, context)
            : undefined,
    };
};
const deserializeAws_json1_1DescribeParametersResponse = (output, context) => {
    return {
        NextToken: (0, smithy_client_1.expectString)(output.NextToken),
        Parameters: output.Parameters !== undefined && output.Parameters !== null
            ? deserializeAws_json1_1ParametersList(output.Parameters, context)
            : undefined,
    };
};
const deserializeAws_json1_1DescribeServiceUpdatesResponse = (output, context) => {
    return {
        NextToken: (0, smithy_client_1.expectString)(output.NextToken),
        ServiceUpdates: output.ServiceUpdates !== undefined && output.ServiceUpdates !== null
            ? deserializeAws_json1_1ServiceUpdateList(output.ServiceUpdates, context)
            : undefined,
    };
};
const deserializeAws_json1_1DescribeSnapshotsResponse = (output, context) => {
    return {
        NextToken: (0, smithy_client_1.expectString)(output.NextToken),
        Snapshots: output.Snapshots !== undefined && output.Snapshots !== null
            ? deserializeAws_json1_1SnapshotList(output.Snapshots, context)
            : undefined,
    };
};
const deserializeAws_json1_1DescribeSubnetGroupsResponse = (output, context) => {
    return {
        NextToken: (0, smithy_client_1.expectString)(output.NextToken),
        SubnetGroups: output.SubnetGroups !== undefined && output.SubnetGroups !== null
            ? deserializeAws_json1_1SubnetGroupList(output.SubnetGroups, context)
            : undefined,
    };
};
const deserializeAws_json1_1DescribeUsersResponse = (output, context) => {
    return {
        NextToken: (0, smithy_client_1.expectString)(output.NextToken),
        Users: output.Users !== undefined && output.Users !== null
            ? deserializeAws_json1_1UserList(output.Users, context)
            : undefined,
    };
};
const deserializeAws_json1_1DuplicateUserNameFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1Endpoint = (output, context) => {
    return {
        Address: (0, smithy_client_1.expectString)(output.Address),
        Port: (0, smithy_client_1.expectInt32)(output.Port),
    };
};
const deserializeAws_json1_1EngineVersionInfo = (output, context) => {
    return {
        EnginePatchVersion: (0, smithy_client_1.expectString)(output.EnginePatchVersion),
        EngineVersion: (0, smithy_client_1.expectString)(output.EngineVersion),
        ParameterGroupFamily: (0, smithy_client_1.expectString)(output.ParameterGroupFamily),
    };
};
const deserializeAws_json1_1EngineVersionInfoList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1EngineVersionInfo(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1Event = (output, context) => {
    return {
        Date: output.Date !== undefined && output.Date !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.Date)))
            : undefined,
        Message: (0, smithy_client_1.expectString)(output.Message),
        SourceName: (0, smithy_client_1.expectString)(output.SourceName),
        SourceType: (0, smithy_client_1.expectString)(output.SourceType),
    };
};
const deserializeAws_json1_1EventList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1Event(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1FailoverShardResponse = (output, context) => {
    return {
        Cluster: output.Cluster !== undefined && output.Cluster !== null
            ? deserializeAws_json1_1Cluster(output.Cluster, context)
            : undefined,
    };
};
const deserializeAws_json1_1InsufficientClusterCapacityFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1InvalidACLStateFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1InvalidARNFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1InvalidClusterStateFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1InvalidCredentialsException = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1InvalidKMSKeyFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1InvalidNodeStateFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1InvalidParameterCombinationException = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1InvalidParameterGroupStateFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1InvalidParameterValueException = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1InvalidSnapshotStateFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1InvalidSubnet = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1InvalidUserStateFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1InvalidVPCNetworkStateFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1ListAllowedNodeTypeUpdatesResponse = (output, context) => {
    return {
        ScaleDownNodeTypes: output.ScaleDownNodeTypes !== undefined && output.ScaleDownNodeTypes !== null
            ? deserializeAws_json1_1NodeTypeList(output.ScaleDownNodeTypes, context)
            : undefined,
        ScaleUpNodeTypes: output.ScaleUpNodeTypes !== undefined && output.ScaleUpNodeTypes !== null
            ? deserializeAws_json1_1NodeTypeList(output.ScaleUpNodeTypes, context)
            : undefined,
    };
};
const deserializeAws_json1_1ListTagsResponse = (output, context) => {
    return {
        TagList: output.TagList !== undefined && output.TagList !== null
            ? deserializeAws_json1_1TagList(output.TagList, context)
            : undefined,
    };
};
const deserializeAws_json1_1Node = (output, context) => {
    return {
        AvailabilityZone: (0, smithy_client_1.expectString)(output.AvailabilityZone),
        CreateTime: output.CreateTime !== undefined && output.CreateTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.CreateTime)))
            : undefined,
        Endpoint: output.Endpoint !== undefined && output.Endpoint !== null
            ? deserializeAws_json1_1Endpoint(output.Endpoint, context)
            : undefined,
        Name: (0, smithy_client_1.expectString)(output.Name),
        Status: (0, smithy_client_1.expectString)(output.Status),
    };
};
const deserializeAws_json1_1NodeList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1Node(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1NodeQuotaForClusterExceededFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1NodeQuotaForCustomerExceededFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1NodeTypeList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return (0, smithy_client_1.expectString)(entry);
    });
    return retVal;
};
const deserializeAws_json1_1NoOperationFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1Parameter = (output, context) => {
    return {
        AllowedValues: (0, smithy_client_1.expectString)(output.AllowedValues),
        DataType: (0, smithy_client_1.expectString)(output.DataType),
        Description: (0, smithy_client_1.expectString)(output.Description),
        MinimumEngineVersion: (0, smithy_client_1.expectString)(output.MinimumEngineVersion),
        Name: (0, smithy_client_1.expectString)(output.Name),
        Value: (0, smithy_client_1.expectString)(output.Value),
    };
};
const deserializeAws_json1_1ParameterGroup = (output, context) => {
    return {
        ARN: (0, smithy_client_1.expectString)(output.ARN),
        Description: (0, smithy_client_1.expectString)(output.Description),
        Family: (0, smithy_client_1.expectString)(output.Family),
        Name: (0, smithy_client_1.expectString)(output.Name),
    };
};
const deserializeAws_json1_1ParameterGroupAlreadyExistsFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1ParameterGroupList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1ParameterGroup(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1ParameterGroupNotFoundFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1ParameterGroupQuotaExceededFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1ParametersList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1Parameter(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1PendingModifiedServiceUpdate = (output, context) => {
    return {
        ServiceUpdateName: (0, smithy_client_1.expectString)(output.ServiceUpdateName),
        Status: (0, smithy_client_1.expectString)(output.Status),
    };
};
const deserializeAws_json1_1PendingModifiedServiceUpdateList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1PendingModifiedServiceUpdate(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1ResetParameterGroupResponse = (output, context) => {
    return {
        ParameterGroup: output.ParameterGroup !== undefined && output.ParameterGroup !== null
            ? deserializeAws_json1_1ParameterGroup(output.ParameterGroup, context)
            : undefined,
    };
};
const deserializeAws_json1_1ReshardingStatus = (output, context) => {
    return {
        SlotMigration: output.SlotMigration !== undefined && output.SlotMigration !== null
            ? deserializeAws_json1_1SlotMigration(output.SlotMigration, context)
            : undefined,
    };
};
const deserializeAws_json1_1SecurityGroupMembership = (output, context) => {
    return {
        SecurityGroupId: (0, smithy_client_1.expectString)(output.SecurityGroupId),
        Status: (0, smithy_client_1.expectString)(output.Status),
    };
};
const deserializeAws_json1_1SecurityGroupMembershipList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1SecurityGroupMembership(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1ServiceLinkedRoleNotFoundFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1ServiceUpdate = (output, context) => {
    return {
        AutoUpdateStartDate: output.AutoUpdateStartDate !== undefined && output.AutoUpdateStartDate !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.AutoUpdateStartDate)))
            : undefined,
        ClusterName: (0, smithy_client_1.expectString)(output.ClusterName),
        Description: (0, smithy_client_1.expectString)(output.Description),
        NodesUpdated: (0, smithy_client_1.expectString)(output.NodesUpdated),
        ReleaseDate: output.ReleaseDate !== undefined && output.ReleaseDate !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.ReleaseDate)))
            : undefined,
        ServiceUpdateName: (0, smithy_client_1.expectString)(output.ServiceUpdateName),
        Status: (0, smithy_client_1.expectString)(output.Status),
        Type: (0, smithy_client_1.expectString)(output.Type),
    };
};
const deserializeAws_json1_1ServiceUpdateList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1ServiceUpdate(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1ServiceUpdateNotFoundFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1Shard = (output, context) => {
    return {
        Name: (0, smithy_client_1.expectString)(output.Name),
        Nodes: output.Nodes !== undefined && output.Nodes !== null
            ? deserializeAws_json1_1NodeList(output.Nodes, context)
            : undefined,
        NumberOfNodes: (0, smithy_client_1.expectInt32)(output.NumberOfNodes),
        Slots: (0, smithy_client_1.expectString)(output.Slots),
        Status: (0, smithy_client_1.expectString)(output.Status),
    };
};
const deserializeAws_json1_1ShardConfiguration = (output, context) => {
    return {
        ReplicaCount: (0, smithy_client_1.expectInt32)(output.ReplicaCount),
        Slots: (0, smithy_client_1.expectString)(output.Slots),
    };
};
const deserializeAws_json1_1ShardDetail = (output, context) => {
    return {
        Configuration: output.Configuration !== undefined && output.Configuration !== null
            ? deserializeAws_json1_1ShardConfiguration(output.Configuration, context)
            : undefined,
        Name: (0, smithy_client_1.expectString)(output.Name),
        Size: (0, smithy_client_1.expectString)(output.Size),
        SnapshotCreationTime: output.SnapshotCreationTime !== undefined && output.SnapshotCreationTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.SnapshotCreationTime)))
            : undefined,
    };
};
const deserializeAws_json1_1ShardDetails = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1ShardDetail(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1ShardList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1Shard(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1ShardNotFoundFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1ShardsPerClusterQuotaExceededFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1SlotMigration = (output, context) => {
    return {
        ProgressPercentage: (0, smithy_client_1.limitedParseDouble)(output.ProgressPercentage),
    };
};
const deserializeAws_json1_1Snapshot = (output, context) => {
    return {
        ARN: (0, smithy_client_1.expectString)(output.ARN),
        ClusterConfiguration: output.ClusterConfiguration !== undefined && output.ClusterConfiguration !== null
            ? deserializeAws_json1_1ClusterConfiguration(output.ClusterConfiguration, context)
            : undefined,
        KmsKeyId: (0, smithy_client_1.expectString)(output.KmsKeyId),
        Name: (0, smithy_client_1.expectString)(output.Name),
        Source: (0, smithy_client_1.expectString)(output.Source),
        Status: (0, smithy_client_1.expectString)(output.Status),
    };
};
const deserializeAws_json1_1SnapshotAlreadyExistsFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1SnapshotList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1Snapshot(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1SnapshotNotFoundFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1SnapshotQuotaExceededFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1Subnet = (output, context) => {
    return {
        AvailabilityZone: output.AvailabilityZone !== undefined && output.AvailabilityZone !== null
            ? deserializeAws_json1_1AvailabilityZone(output.AvailabilityZone, context)
            : undefined,
        Identifier: (0, smithy_client_1.expectString)(output.Identifier),
    };
};
const deserializeAws_json1_1SubnetGroup = (output, context) => {
    return {
        ARN: (0, smithy_client_1.expectString)(output.ARN),
        Description: (0, smithy_client_1.expectString)(output.Description),
        Name: (0, smithy_client_1.expectString)(output.Name),
        Subnets: output.Subnets !== undefined && output.Subnets !== null
            ? deserializeAws_json1_1SubnetList(output.Subnets, context)
            : undefined,
        VpcId: (0, smithy_client_1.expectString)(output.VpcId),
    };
};
const deserializeAws_json1_1SubnetGroupAlreadyExistsFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1SubnetGroupInUseFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1SubnetGroupList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1SubnetGroup(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1SubnetGroupNotFoundFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1SubnetGroupQuotaExceededFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1SubnetInUse = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1SubnetList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1Subnet(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1SubnetNotAllowedFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1SubnetQuotaExceededFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1Tag = (output, context) => {
    return {
        Key: (0, smithy_client_1.expectString)(output.Key),
        Value: (0, smithy_client_1.expectString)(output.Value),
    };
};
const deserializeAws_json1_1TagList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1Tag(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1TagNotFoundFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1TagQuotaPerResourceExceeded = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1TagResourceResponse = (output, context) => {
    return {
        TagList: output.TagList !== undefined && output.TagList !== null
            ? deserializeAws_json1_1TagList(output.TagList, context)
            : undefined,
    };
};
const deserializeAws_json1_1TestFailoverNotAvailableFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1UnprocessedCluster = (output, context) => {
    return {
        ClusterName: (0, smithy_client_1.expectString)(output.ClusterName),
        ErrorMessage: (0, smithy_client_1.expectString)(output.ErrorMessage),
        ErrorType: (0, smithy_client_1.expectString)(output.ErrorType),
    };
};
const deserializeAws_json1_1UnprocessedClusterList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1UnprocessedCluster(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1UntagResourceResponse = (output, context) => {
    return {
        TagList: output.TagList !== undefined && output.TagList !== null
            ? deserializeAws_json1_1TagList(output.TagList, context)
            : undefined,
    };
};
const deserializeAws_json1_1UpdateACLResponse = (output, context) => {
    return {
        ACL: output.ACL !== undefined && output.ACL !== null ? deserializeAws_json1_1ACL(output.ACL, context) : undefined,
    };
};
const deserializeAws_json1_1UpdateClusterResponse = (output, context) => {
    return {
        Cluster: output.Cluster !== undefined && output.Cluster !== null
            ? deserializeAws_json1_1Cluster(output.Cluster, context)
            : undefined,
    };
};
const deserializeAws_json1_1UpdateParameterGroupResponse = (output, context) => {
    return {
        ParameterGroup: output.ParameterGroup !== undefined && output.ParameterGroup !== null
            ? deserializeAws_json1_1ParameterGroup(output.ParameterGroup, context)
            : undefined,
    };
};
const deserializeAws_json1_1UpdateSubnetGroupResponse = (output, context) => {
    return {
        SubnetGroup: output.SubnetGroup !== undefined && output.SubnetGroup !== null
            ? deserializeAws_json1_1SubnetGroup(output.SubnetGroup, context)
            : undefined,
    };
};
const deserializeAws_json1_1UpdateUserResponse = (output, context) => {
    return {
        User: output.User !== undefined && output.User !== null ? deserializeAws_json1_1User(output.User, context) : undefined,
    };
};
const deserializeAws_json1_1User = (output, context) => {
    return {
        ACLNames: output.ACLNames !== undefined && output.ACLNames !== null
            ? deserializeAws_json1_1ACLNameList(output.ACLNames, context)
            : undefined,
        ARN: (0, smithy_client_1.expectString)(output.ARN),
        AccessString: (0, smithy_client_1.expectString)(output.AccessString),
        Authentication: output.Authentication !== undefined && output.Authentication !== null
            ? deserializeAws_json1_1Authentication(output.Authentication, context)
            : undefined,
        MinimumEngineVersion: (0, smithy_client_1.expectString)(output.MinimumEngineVersion),
        Name: (0, smithy_client_1.expectString)(output.Name),
        Status: (0, smithy_client_1.expectString)(output.Status),
    };
};
const deserializeAws_json1_1UserAlreadyExistsFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1UserList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1User(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1UserNameList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return (0, smithy_client_1.expectString)(entry);
    });
    return retVal;
};
const deserializeAws_json1_1UserNotFoundFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeAws_json1_1UserQuotaExceededFault = (output, context) => {
    return {
        message: (0, smithy_client_1.expectString)(output.message),
    };
};
const deserializeMetadata = (output) => {
    var _a;
    return ({
        httpStatusCode: output.statusCode,
        requestId: (_a = output.headers["x-amzn-requestid"]) !== null && _a !== void 0 ? _a : output.headers["x-amzn-request-id"],
        extendedRequestId: output.headers["x-amz-id-2"],
        cfId: output.headers["x-amz-cf-id"],
    });
};
const collectBody = (streamBody = new Uint8Array(), context) => {
    if (streamBody instanceof Uint8Array) {
        return Promise.resolve(streamBody);
    }
    return context.streamCollector(streamBody) || Promise.resolve(new Uint8Array());
};
const collectBodyString = (streamBody, context) => collectBody(streamBody, context).then((body) => context.utf8Encoder(body));
const buildHttpRpcRequest = async (context, headers, path, resolvedHostname, body) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const contents = {
        protocol,
        hostname,
        port,
        method: "POST",
        path: basePath.endsWith("/") ? basePath.slice(0, -1) + path : basePath + path,
        headers,
    };
    if (resolvedHostname !== undefined) {
        contents.hostname = resolvedHostname;
    }
    if (body !== undefined) {
        contents.body = body;
    }
    return new protocol_http_1.HttpRequest(contents);
};
const parseBody = (streamBody, context) => collectBodyString(streamBody, context).then((encoded) => {
    if (encoded.length) {
        return JSON.parse(encoded);
    }
    return {};
});
const loadRestJsonErrorCode = (output, data) => {
    const findKey = (object, key) => Object.keys(object).find((k) => k.toLowerCase() === key.toLowerCase());
    const sanitizeErrorCode = (rawValue) => {
        let cleanValue = rawValue;
        if (cleanValue.indexOf(":") >= 0) {
            cleanValue = cleanValue.split(":")[0];
        }
        if (cleanValue.indexOf("#") >= 0) {
            cleanValue = cleanValue.split("#")[1];
        }
        return cleanValue;
    };
    const headerKey = findKey(output.headers, "x-amzn-errortype");
    if (headerKey !== undefined) {
        return sanitizeErrorCode(output.headers[headerKey]);
    }
    if (data.code !== undefined) {
        return sanitizeErrorCode(data.code);
    }
    if (data["__type"] !== undefined) {
        return sanitizeErrorCode(data["__type"]);
    }
    return "";
};
