import { __assign, __extends } from "tslib";
import { MemoryDBServiceException as __BaseException } from "./MemoryDBServiceException";
export var ACLPendingChanges;
(function (ACLPendingChanges) {
    ACLPendingChanges.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ACLPendingChanges || (ACLPendingChanges = {}));
export var ACL;
(function (ACL) {
    ACL.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ACL || (ACL = {}));
var ACLAlreadyExistsFault = (function (_super) {
    __extends(ACLAlreadyExistsFault, _super);
    function ACLAlreadyExistsFault(opts) {
        var _this = _super.call(this, __assign({ name: "ACLAlreadyExistsFault", $fault: "client" }, opts)) || this;
        _this.name = "ACLAlreadyExistsFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ACLAlreadyExistsFault.prototype);
        return _this;
    }
    return ACLAlreadyExistsFault;
}(__BaseException));
export { ACLAlreadyExistsFault };
var ACLNotFoundFault = (function (_super) {
    __extends(ACLNotFoundFault, _super);
    function ACLNotFoundFault(opts) {
        var _this = _super.call(this, __assign({ name: "ACLNotFoundFault", $fault: "client" }, opts)) || this;
        _this.name = "ACLNotFoundFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ACLNotFoundFault.prototype);
        return _this;
    }
    return ACLNotFoundFault;
}(__BaseException));
export { ACLNotFoundFault };
var ACLQuotaExceededFault = (function (_super) {
    __extends(ACLQuotaExceededFault, _super);
    function ACLQuotaExceededFault(opts) {
        var _this = _super.call(this, __assign({ name: "ACLQuotaExceededFault", $fault: "client" }, opts)) || this;
        _this.name = "ACLQuotaExceededFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ACLQuotaExceededFault.prototype);
        return _this;
    }
    return ACLQuotaExceededFault;
}(__BaseException));
export { ACLQuotaExceededFault };
export var ACLsUpdateStatus;
(function (ACLsUpdateStatus) {
    ACLsUpdateStatus.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ACLsUpdateStatus || (ACLsUpdateStatus = {}));
export var ServiceUpdateRequest;
(function (ServiceUpdateRequest) {
    ServiceUpdateRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ServiceUpdateRequest || (ServiceUpdateRequest = {}));
export var BatchUpdateClusterRequest;
(function (BatchUpdateClusterRequest) {
    BatchUpdateClusterRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(BatchUpdateClusterRequest || (BatchUpdateClusterRequest = {}));
export var AZStatus;
(function (AZStatus) {
    AZStatus["MultiAZ"] = "multiaz";
    AZStatus["SingleAZ"] = "singleaz";
})(AZStatus || (AZStatus = {}));
export var Endpoint;
(function (Endpoint) {
    Endpoint.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Endpoint || (Endpoint = {}));
export var SlotMigration;
(function (SlotMigration) {
    SlotMigration.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(SlotMigration || (SlotMigration = {}));
export var ReshardingStatus;
(function (ReshardingStatus) {
    ReshardingStatus.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ReshardingStatus || (ReshardingStatus = {}));
export var ServiceUpdateStatus;
(function (ServiceUpdateStatus) {
    ServiceUpdateStatus["COMPLETE"] = "complete";
    ServiceUpdateStatus["IN_PROGRESS"] = "in-progress";
    ServiceUpdateStatus["NOT_APPLIED"] = "available";
    ServiceUpdateStatus["SCHEDULED"] = "scheduled";
})(ServiceUpdateStatus || (ServiceUpdateStatus = {}));
export var PendingModifiedServiceUpdate;
(function (PendingModifiedServiceUpdate) {
    PendingModifiedServiceUpdate.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(PendingModifiedServiceUpdate || (PendingModifiedServiceUpdate = {}));
export var ClusterPendingUpdates;
(function (ClusterPendingUpdates) {
    ClusterPendingUpdates.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ClusterPendingUpdates || (ClusterPendingUpdates = {}));
export var SecurityGroupMembership;
(function (SecurityGroupMembership) {
    SecurityGroupMembership.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(SecurityGroupMembership || (SecurityGroupMembership = {}));
export var Node;
(function (Node) {
    Node.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Node || (Node = {}));
export var Shard;
(function (Shard) {
    Shard.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Shard || (Shard = {}));
export var Cluster;
(function (Cluster) {
    Cluster.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Cluster || (Cluster = {}));
export var UnprocessedCluster;
(function (UnprocessedCluster) {
    UnprocessedCluster.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UnprocessedCluster || (UnprocessedCluster = {}));
export var BatchUpdateClusterResponse;
(function (BatchUpdateClusterResponse) {
    BatchUpdateClusterResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(BatchUpdateClusterResponse || (BatchUpdateClusterResponse = {}));
var InvalidParameterValueException = (function (_super) {
    __extends(InvalidParameterValueException, _super);
    function InvalidParameterValueException(opts) {
        var _this = _super.call(this, __assign({ name: "InvalidParameterValueException", $fault: "client" }, opts)) || this;
        _this.name = "InvalidParameterValueException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, InvalidParameterValueException.prototype);
        return _this;
    }
    return InvalidParameterValueException;
}(__BaseException));
export { InvalidParameterValueException };
var ServiceUpdateNotFoundFault = (function (_super) {
    __extends(ServiceUpdateNotFoundFault, _super);
    function ServiceUpdateNotFoundFault(opts) {
        var _this = _super.call(this, __assign({ name: "ServiceUpdateNotFoundFault", $fault: "client" }, opts)) || this;
        _this.name = "ServiceUpdateNotFoundFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ServiceUpdateNotFoundFault.prototype);
        return _this;
    }
    return ServiceUpdateNotFoundFault;
}(__BaseException));
export { ServiceUpdateNotFoundFault };
export var Tag;
(function (Tag) {
    Tag.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Tag || (Tag = {}));
export var CopySnapshotRequest;
(function (CopySnapshotRequest) {
    CopySnapshotRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CopySnapshotRequest || (CopySnapshotRequest = {}));
export var ShardConfiguration;
(function (ShardConfiguration) {
    ShardConfiguration.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ShardConfiguration || (ShardConfiguration = {}));
export var ShardDetail;
(function (ShardDetail) {
    ShardDetail.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ShardDetail || (ShardDetail = {}));
export var ClusterConfiguration;
(function (ClusterConfiguration) {
    ClusterConfiguration.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ClusterConfiguration || (ClusterConfiguration = {}));
export var Snapshot;
(function (Snapshot) {
    Snapshot.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Snapshot || (Snapshot = {}));
export var CopySnapshotResponse;
(function (CopySnapshotResponse) {
    CopySnapshotResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CopySnapshotResponse || (CopySnapshotResponse = {}));
var InvalidParameterCombinationException = (function (_super) {
    __extends(InvalidParameterCombinationException, _super);
    function InvalidParameterCombinationException(opts) {
        var _this = _super.call(this, __assign({ name: "InvalidParameterCombinationException", $fault: "client" }, opts)) || this;
        _this.name = "InvalidParameterCombinationException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, InvalidParameterCombinationException.prototype);
        return _this;
    }
    return InvalidParameterCombinationException;
}(__BaseException));
export { InvalidParameterCombinationException };
var InvalidSnapshotStateFault = (function (_super) {
    __extends(InvalidSnapshotStateFault, _super);
    function InvalidSnapshotStateFault(opts) {
        var _this = _super.call(this, __assign({ name: "InvalidSnapshotStateFault", $fault: "client" }, opts)) || this;
        _this.name = "InvalidSnapshotStateFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, InvalidSnapshotStateFault.prototype);
        return _this;
    }
    return InvalidSnapshotStateFault;
}(__BaseException));
export { InvalidSnapshotStateFault };
var ServiceLinkedRoleNotFoundFault = (function (_super) {
    __extends(ServiceLinkedRoleNotFoundFault, _super);
    function ServiceLinkedRoleNotFoundFault(opts) {
        var _this = _super.call(this, __assign({ name: "ServiceLinkedRoleNotFoundFault", $fault: "client" }, opts)) || this;
        _this.name = "ServiceLinkedRoleNotFoundFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ServiceLinkedRoleNotFoundFault.prototype);
        return _this;
    }
    return ServiceLinkedRoleNotFoundFault;
}(__BaseException));
export { ServiceLinkedRoleNotFoundFault };
var SnapshotAlreadyExistsFault = (function (_super) {
    __extends(SnapshotAlreadyExistsFault, _super);
    function SnapshotAlreadyExistsFault(opts) {
        var _this = _super.call(this, __assign({ name: "SnapshotAlreadyExistsFault", $fault: "client" }, opts)) || this;
        _this.name = "SnapshotAlreadyExistsFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, SnapshotAlreadyExistsFault.prototype);
        return _this;
    }
    return SnapshotAlreadyExistsFault;
}(__BaseException));
export { SnapshotAlreadyExistsFault };
var SnapshotNotFoundFault = (function (_super) {
    __extends(SnapshotNotFoundFault, _super);
    function SnapshotNotFoundFault(opts) {
        var _this = _super.call(this, __assign({ name: "SnapshotNotFoundFault", $fault: "client" }, opts)) || this;
        _this.name = "SnapshotNotFoundFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, SnapshotNotFoundFault.prototype);
        return _this;
    }
    return SnapshotNotFoundFault;
}(__BaseException));
export { SnapshotNotFoundFault };
var SnapshotQuotaExceededFault = (function (_super) {
    __extends(SnapshotQuotaExceededFault, _super);
    function SnapshotQuotaExceededFault(opts) {
        var _this = _super.call(this, __assign({ name: "SnapshotQuotaExceededFault", $fault: "client" }, opts)) || this;
        _this.name = "SnapshotQuotaExceededFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, SnapshotQuotaExceededFault.prototype);
        return _this;
    }
    return SnapshotQuotaExceededFault;
}(__BaseException));
export { SnapshotQuotaExceededFault };
var TagQuotaPerResourceExceeded = (function (_super) {
    __extends(TagQuotaPerResourceExceeded, _super);
    function TagQuotaPerResourceExceeded(opts) {
        var _this = _super.call(this, __assign({ name: "TagQuotaPerResourceExceeded", $fault: "client" }, opts)) || this;
        _this.name = "TagQuotaPerResourceExceeded";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, TagQuotaPerResourceExceeded.prototype);
        return _this;
    }
    return TagQuotaPerResourceExceeded;
}(__BaseException));
export { TagQuotaPerResourceExceeded };
export var CreateACLRequest;
(function (CreateACLRequest) {
    CreateACLRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateACLRequest || (CreateACLRequest = {}));
export var CreateACLResponse;
(function (CreateACLResponse) {
    CreateACLResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateACLResponse || (CreateACLResponse = {}));
var DefaultUserRequired = (function (_super) {
    __extends(DefaultUserRequired, _super);
    function DefaultUserRequired(opts) {
        var _this = _super.call(this, __assign({ name: "DefaultUserRequired", $fault: "client" }, opts)) || this;
        _this.name = "DefaultUserRequired";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, DefaultUserRequired.prototype);
        return _this;
    }
    return DefaultUserRequired;
}(__BaseException));
export { DefaultUserRequired };
var DuplicateUserNameFault = (function (_super) {
    __extends(DuplicateUserNameFault, _super);
    function DuplicateUserNameFault(opts) {
        var _this = _super.call(this, __assign({ name: "DuplicateUserNameFault", $fault: "client" }, opts)) || this;
        _this.name = "DuplicateUserNameFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, DuplicateUserNameFault.prototype);
        return _this;
    }
    return DuplicateUserNameFault;
}(__BaseException));
export { DuplicateUserNameFault };
var UserNotFoundFault = (function (_super) {
    __extends(UserNotFoundFault, _super);
    function UserNotFoundFault(opts) {
        var _this = _super.call(this, __assign({ name: "UserNotFoundFault", $fault: "client" }, opts)) || this;
        _this.name = "UserNotFoundFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, UserNotFoundFault.prototype);
        return _this;
    }
    return UserNotFoundFault;
}(__BaseException));
export { UserNotFoundFault };
var ClusterAlreadyExistsFault = (function (_super) {
    __extends(ClusterAlreadyExistsFault, _super);
    function ClusterAlreadyExistsFault(opts) {
        var _this = _super.call(this, __assign({ name: "ClusterAlreadyExistsFault", $fault: "client" }, opts)) || this;
        _this.name = "ClusterAlreadyExistsFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ClusterAlreadyExistsFault.prototype);
        return _this;
    }
    return ClusterAlreadyExistsFault;
}(__BaseException));
export { ClusterAlreadyExistsFault };
var ClusterQuotaForCustomerExceededFault = (function (_super) {
    __extends(ClusterQuotaForCustomerExceededFault, _super);
    function ClusterQuotaForCustomerExceededFault(opts) {
        var _this = _super.call(this, __assign({ name: "ClusterQuotaForCustomerExceededFault", $fault: "client" }, opts)) || this;
        _this.name = "ClusterQuotaForCustomerExceededFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ClusterQuotaForCustomerExceededFault.prototype);
        return _this;
    }
    return ClusterQuotaForCustomerExceededFault;
}(__BaseException));
export { ClusterQuotaForCustomerExceededFault };
export var CreateClusterRequest;
(function (CreateClusterRequest) {
    CreateClusterRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateClusterRequest || (CreateClusterRequest = {}));
export var CreateClusterResponse;
(function (CreateClusterResponse) {
    CreateClusterResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateClusterResponse || (CreateClusterResponse = {}));
var InsufficientClusterCapacityFault = (function (_super) {
    __extends(InsufficientClusterCapacityFault, _super);
    function InsufficientClusterCapacityFault(opts) {
        var _this = _super.call(this, __assign({ name: "InsufficientClusterCapacityFault", $fault: "client" }, opts)) || this;
        _this.name = "InsufficientClusterCapacityFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, InsufficientClusterCapacityFault.prototype);
        return _this;
    }
    return InsufficientClusterCapacityFault;
}(__BaseException));
export { InsufficientClusterCapacityFault };
var InvalidACLStateFault = (function (_super) {
    __extends(InvalidACLStateFault, _super);
    function InvalidACLStateFault(opts) {
        var _this = _super.call(this, __assign({ name: "InvalidACLStateFault", $fault: "client" }, opts)) || this;
        _this.name = "InvalidACLStateFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, InvalidACLStateFault.prototype);
        return _this;
    }
    return InvalidACLStateFault;
}(__BaseException));
export { InvalidACLStateFault };
var InvalidCredentialsException = (function (_super) {
    __extends(InvalidCredentialsException, _super);
    function InvalidCredentialsException(opts) {
        var _this = _super.call(this, __assign({ name: "InvalidCredentialsException", $fault: "client" }, opts)) || this;
        _this.name = "InvalidCredentialsException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, InvalidCredentialsException.prototype);
        return _this;
    }
    return InvalidCredentialsException;
}(__BaseException));
export { InvalidCredentialsException };
var InvalidVPCNetworkStateFault = (function (_super) {
    __extends(InvalidVPCNetworkStateFault, _super);
    function InvalidVPCNetworkStateFault(opts) {
        var _this = _super.call(this, __assign({ name: "InvalidVPCNetworkStateFault", $fault: "client" }, opts)) || this;
        _this.name = "InvalidVPCNetworkStateFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, InvalidVPCNetworkStateFault.prototype);
        return _this;
    }
    return InvalidVPCNetworkStateFault;
}(__BaseException));
export { InvalidVPCNetworkStateFault };
var NodeQuotaForClusterExceededFault = (function (_super) {
    __extends(NodeQuotaForClusterExceededFault, _super);
    function NodeQuotaForClusterExceededFault(opts) {
        var _this = _super.call(this, __assign({ name: "NodeQuotaForClusterExceededFault", $fault: "client" }, opts)) || this;
        _this.name = "NodeQuotaForClusterExceededFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, NodeQuotaForClusterExceededFault.prototype);
        return _this;
    }
    return NodeQuotaForClusterExceededFault;
}(__BaseException));
export { NodeQuotaForClusterExceededFault };
var NodeQuotaForCustomerExceededFault = (function (_super) {
    __extends(NodeQuotaForCustomerExceededFault, _super);
    function NodeQuotaForCustomerExceededFault(opts) {
        var _this = _super.call(this, __assign({ name: "NodeQuotaForCustomerExceededFault", $fault: "client" }, opts)) || this;
        _this.name = "NodeQuotaForCustomerExceededFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, NodeQuotaForCustomerExceededFault.prototype);
        return _this;
    }
    return NodeQuotaForCustomerExceededFault;
}(__BaseException));
export { NodeQuotaForCustomerExceededFault };
var ParameterGroupNotFoundFault = (function (_super) {
    __extends(ParameterGroupNotFoundFault, _super);
    function ParameterGroupNotFoundFault(opts) {
        var _this = _super.call(this, __assign({ name: "ParameterGroupNotFoundFault", $fault: "client" }, opts)) || this;
        _this.name = "ParameterGroupNotFoundFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ParameterGroupNotFoundFault.prototype);
        return _this;
    }
    return ParameterGroupNotFoundFault;
}(__BaseException));
export { ParameterGroupNotFoundFault };
var ShardsPerClusterQuotaExceededFault = (function (_super) {
    __extends(ShardsPerClusterQuotaExceededFault, _super);
    function ShardsPerClusterQuotaExceededFault(opts) {
        var _this = _super.call(this, __assign({ name: "ShardsPerClusterQuotaExceededFault", $fault: "client" }, opts)) || this;
        _this.name = "ShardsPerClusterQuotaExceededFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ShardsPerClusterQuotaExceededFault.prototype);
        return _this;
    }
    return ShardsPerClusterQuotaExceededFault;
}(__BaseException));
export { ShardsPerClusterQuotaExceededFault };
var SubnetGroupNotFoundFault = (function (_super) {
    __extends(SubnetGroupNotFoundFault, _super);
    function SubnetGroupNotFoundFault(opts) {
        var _this = _super.call(this, __assign({ name: "SubnetGroupNotFoundFault", $fault: "client" }, opts)) || this;
        _this.name = "SubnetGroupNotFoundFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, SubnetGroupNotFoundFault.prototype);
        return _this;
    }
    return SubnetGroupNotFoundFault;
}(__BaseException));
export { SubnetGroupNotFoundFault };
export var CreateParameterGroupRequest;
(function (CreateParameterGroupRequest) {
    CreateParameterGroupRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateParameterGroupRequest || (CreateParameterGroupRequest = {}));
export var ParameterGroup;
(function (ParameterGroup) {
    ParameterGroup.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ParameterGroup || (ParameterGroup = {}));
export var CreateParameterGroupResponse;
(function (CreateParameterGroupResponse) {
    CreateParameterGroupResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateParameterGroupResponse || (CreateParameterGroupResponse = {}));
var InvalidParameterGroupStateFault = (function (_super) {
    __extends(InvalidParameterGroupStateFault, _super);
    function InvalidParameterGroupStateFault(opts) {
        var _this = _super.call(this, __assign({ name: "InvalidParameterGroupStateFault", $fault: "client" }, opts)) || this;
        _this.name = "InvalidParameterGroupStateFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, InvalidParameterGroupStateFault.prototype);
        return _this;
    }
    return InvalidParameterGroupStateFault;
}(__BaseException));
export { InvalidParameterGroupStateFault };
var ParameterGroupAlreadyExistsFault = (function (_super) {
    __extends(ParameterGroupAlreadyExistsFault, _super);
    function ParameterGroupAlreadyExistsFault(opts) {
        var _this = _super.call(this, __assign({ name: "ParameterGroupAlreadyExistsFault", $fault: "client" }, opts)) || this;
        _this.name = "ParameterGroupAlreadyExistsFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ParameterGroupAlreadyExistsFault.prototype);
        return _this;
    }
    return ParameterGroupAlreadyExistsFault;
}(__BaseException));
export { ParameterGroupAlreadyExistsFault };
var ParameterGroupQuotaExceededFault = (function (_super) {
    __extends(ParameterGroupQuotaExceededFault, _super);
    function ParameterGroupQuotaExceededFault(opts) {
        var _this = _super.call(this, __assign({ name: "ParameterGroupQuotaExceededFault", $fault: "client" }, opts)) || this;
        _this.name = "ParameterGroupQuotaExceededFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ParameterGroupQuotaExceededFault.prototype);
        return _this;
    }
    return ParameterGroupQuotaExceededFault;
}(__BaseException));
export { ParameterGroupQuotaExceededFault };
var ClusterNotFoundFault = (function (_super) {
    __extends(ClusterNotFoundFault, _super);
    function ClusterNotFoundFault(opts) {
        var _this = _super.call(this, __assign({ name: "ClusterNotFoundFault", $fault: "client" }, opts)) || this;
        _this.name = "ClusterNotFoundFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ClusterNotFoundFault.prototype);
        return _this;
    }
    return ClusterNotFoundFault;
}(__BaseException));
export { ClusterNotFoundFault };
export var CreateSnapshotRequest;
(function (CreateSnapshotRequest) {
    CreateSnapshotRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateSnapshotRequest || (CreateSnapshotRequest = {}));
export var CreateSnapshotResponse;
(function (CreateSnapshotResponse) {
    CreateSnapshotResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateSnapshotResponse || (CreateSnapshotResponse = {}));
var InvalidClusterStateFault = (function (_super) {
    __extends(InvalidClusterStateFault, _super);
    function InvalidClusterStateFault(opts) {
        var _this = _super.call(this, __assign({ name: "InvalidClusterStateFault", $fault: "client" }, opts)) || this;
        _this.name = "InvalidClusterStateFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, InvalidClusterStateFault.prototype);
        return _this;
    }
    return InvalidClusterStateFault;
}(__BaseException));
export { InvalidClusterStateFault };
export var CreateSubnetGroupRequest;
(function (CreateSubnetGroupRequest) {
    CreateSubnetGroupRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateSubnetGroupRequest || (CreateSubnetGroupRequest = {}));
export var AvailabilityZone;
(function (AvailabilityZone) {
    AvailabilityZone.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(AvailabilityZone || (AvailabilityZone = {}));
export var Subnet;
(function (Subnet) {
    Subnet.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Subnet || (Subnet = {}));
export var SubnetGroup;
(function (SubnetGroup) {
    SubnetGroup.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(SubnetGroup || (SubnetGroup = {}));
export var CreateSubnetGroupResponse;
(function (CreateSubnetGroupResponse) {
    CreateSubnetGroupResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateSubnetGroupResponse || (CreateSubnetGroupResponse = {}));
var InvalidSubnet = (function (_super) {
    __extends(InvalidSubnet, _super);
    function InvalidSubnet(opts) {
        var _this = _super.call(this, __assign({ name: "InvalidSubnet", $fault: "client" }, opts)) || this;
        _this.name = "InvalidSubnet";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, InvalidSubnet.prototype);
        return _this;
    }
    return InvalidSubnet;
}(__BaseException));
export { InvalidSubnet };
var SubnetGroupAlreadyExistsFault = (function (_super) {
    __extends(SubnetGroupAlreadyExistsFault, _super);
    function SubnetGroupAlreadyExistsFault(opts) {
        var _this = _super.call(this, __assign({ name: "SubnetGroupAlreadyExistsFault", $fault: "client" }, opts)) || this;
        _this.name = "SubnetGroupAlreadyExistsFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, SubnetGroupAlreadyExistsFault.prototype);
        return _this;
    }
    return SubnetGroupAlreadyExistsFault;
}(__BaseException));
export { SubnetGroupAlreadyExistsFault };
var SubnetGroupQuotaExceededFault = (function (_super) {
    __extends(SubnetGroupQuotaExceededFault, _super);
    function SubnetGroupQuotaExceededFault(opts) {
        var _this = _super.call(this, __assign({ name: "SubnetGroupQuotaExceededFault", $fault: "client" }, opts)) || this;
        _this.name = "SubnetGroupQuotaExceededFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, SubnetGroupQuotaExceededFault.prototype);
        return _this;
    }
    return SubnetGroupQuotaExceededFault;
}(__BaseException));
export { SubnetGroupQuotaExceededFault };
var SubnetNotAllowedFault = (function (_super) {
    __extends(SubnetNotAllowedFault, _super);
    function SubnetNotAllowedFault(opts) {
        var _this = _super.call(this, __assign({ name: "SubnetNotAllowedFault", $fault: "client" }, opts)) || this;
        _this.name = "SubnetNotAllowedFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, SubnetNotAllowedFault.prototype);
        return _this;
    }
    return SubnetNotAllowedFault;
}(__BaseException));
export { SubnetNotAllowedFault };
var SubnetQuotaExceededFault = (function (_super) {
    __extends(SubnetQuotaExceededFault, _super);
    function SubnetQuotaExceededFault(opts) {
        var _this = _super.call(this, __assign({ name: "SubnetQuotaExceededFault", $fault: "client" }, opts)) || this;
        _this.name = "SubnetQuotaExceededFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, SubnetQuotaExceededFault.prototype);
        return _this;
    }
    return SubnetQuotaExceededFault;
}(__BaseException));
export { SubnetQuotaExceededFault };
export var InputAuthenticationType;
(function (InputAuthenticationType) {
    InputAuthenticationType["PASSWORD"] = "password";
})(InputAuthenticationType || (InputAuthenticationType = {}));
export var AuthenticationMode;
(function (AuthenticationMode) {
    AuthenticationMode.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(AuthenticationMode || (AuthenticationMode = {}));
export var CreateUserRequest;
(function (CreateUserRequest) {
    CreateUserRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateUserRequest || (CreateUserRequest = {}));
export var AuthenticationType;
(function (AuthenticationType) {
    AuthenticationType["NO_PASSWORD"] = "no-password";
    AuthenticationType["PASSWORD"] = "password";
})(AuthenticationType || (AuthenticationType = {}));
export var Authentication;
(function (Authentication) {
    Authentication.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Authentication || (Authentication = {}));
export var User;
(function (User) {
    User.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(User || (User = {}));
export var CreateUserResponse;
(function (CreateUserResponse) {
    CreateUserResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateUserResponse || (CreateUserResponse = {}));
var UserAlreadyExistsFault = (function (_super) {
    __extends(UserAlreadyExistsFault, _super);
    function UserAlreadyExistsFault(opts) {
        var _this = _super.call(this, __assign({ name: "UserAlreadyExistsFault", $fault: "client" }, opts)) || this;
        _this.name = "UserAlreadyExistsFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, UserAlreadyExistsFault.prototype);
        return _this;
    }
    return UserAlreadyExistsFault;
}(__BaseException));
export { UserAlreadyExistsFault };
var UserQuotaExceededFault = (function (_super) {
    __extends(UserQuotaExceededFault, _super);
    function UserQuotaExceededFault(opts) {
        var _this = _super.call(this, __assign({ name: "UserQuotaExceededFault", $fault: "client" }, opts)) || this;
        _this.name = "UserQuotaExceededFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, UserQuotaExceededFault.prototype);
        return _this;
    }
    return UserQuotaExceededFault;
}(__BaseException));
export { UserQuotaExceededFault };
export var DeleteACLRequest;
(function (DeleteACLRequest) {
    DeleteACLRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteACLRequest || (DeleteACLRequest = {}));
export var DeleteACLResponse;
(function (DeleteACLResponse) {
    DeleteACLResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteACLResponse || (DeleteACLResponse = {}));
export var DeleteClusterRequest;
(function (DeleteClusterRequest) {
    DeleteClusterRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteClusterRequest || (DeleteClusterRequest = {}));
export var DeleteClusterResponse;
(function (DeleteClusterResponse) {
    DeleteClusterResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteClusterResponse || (DeleteClusterResponse = {}));
export var DeleteParameterGroupRequest;
(function (DeleteParameterGroupRequest) {
    DeleteParameterGroupRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteParameterGroupRequest || (DeleteParameterGroupRequest = {}));
export var DeleteParameterGroupResponse;
(function (DeleteParameterGroupResponse) {
    DeleteParameterGroupResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteParameterGroupResponse || (DeleteParameterGroupResponse = {}));
export var DeleteSnapshotRequest;
(function (DeleteSnapshotRequest) {
    DeleteSnapshotRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteSnapshotRequest || (DeleteSnapshotRequest = {}));
export var DeleteSnapshotResponse;
(function (DeleteSnapshotResponse) {
    DeleteSnapshotResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteSnapshotResponse || (DeleteSnapshotResponse = {}));
export var DeleteSubnetGroupRequest;
(function (DeleteSubnetGroupRequest) {
    DeleteSubnetGroupRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteSubnetGroupRequest || (DeleteSubnetGroupRequest = {}));
export var DeleteSubnetGroupResponse;
(function (DeleteSubnetGroupResponse) {
    DeleteSubnetGroupResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteSubnetGroupResponse || (DeleteSubnetGroupResponse = {}));
var SubnetGroupInUseFault = (function (_super) {
    __extends(SubnetGroupInUseFault, _super);
    function SubnetGroupInUseFault(opts) {
        var _this = _super.call(this, __assign({ name: "SubnetGroupInUseFault", $fault: "client" }, opts)) || this;
        _this.name = "SubnetGroupInUseFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, SubnetGroupInUseFault.prototype);
        return _this;
    }
    return SubnetGroupInUseFault;
}(__BaseException));
export { SubnetGroupInUseFault };
export var DeleteUserRequest;
(function (DeleteUserRequest) {
    DeleteUserRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteUserRequest || (DeleteUserRequest = {}));
export var DeleteUserResponse;
(function (DeleteUserResponse) {
    DeleteUserResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteUserResponse || (DeleteUserResponse = {}));
var InvalidUserStateFault = (function (_super) {
    __extends(InvalidUserStateFault, _super);
    function InvalidUserStateFault(opts) {
        var _this = _super.call(this, __assign({ name: "InvalidUserStateFault", $fault: "client" }, opts)) || this;
        _this.name = "InvalidUserStateFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, InvalidUserStateFault.prototype);
        return _this;
    }
    return InvalidUserStateFault;
}(__BaseException));
export { InvalidUserStateFault };
export var DescribeACLsRequest;
(function (DescribeACLsRequest) {
    DescribeACLsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeACLsRequest || (DescribeACLsRequest = {}));
export var DescribeACLsResponse;
(function (DescribeACLsResponse) {
    DescribeACLsResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeACLsResponse || (DescribeACLsResponse = {}));
export var DescribeClustersRequest;
(function (DescribeClustersRequest) {
    DescribeClustersRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeClustersRequest || (DescribeClustersRequest = {}));
export var DescribeClustersResponse;
(function (DescribeClustersResponse) {
    DescribeClustersResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeClustersResponse || (DescribeClustersResponse = {}));
export var DescribeEngineVersionsRequest;
(function (DescribeEngineVersionsRequest) {
    DescribeEngineVersionsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeEngineVersionsRequest || (DescribeEngineVersionsRequest = {}));
export var EngineVersionInfo;
(function (EngineVersionInfo) {
    EngineVersionInfo.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(EngineVersionInfo || (EngineVersionInfo = {}));
export var DescribeEngineVersionsResponse;
(function (DescribeEngineVersionsResponse) {
    DescribeEngineVersionsResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeEngineVersionsResponse || (DescribeEngineVersionsResponse = {}));
export var SourceType;
(function (SourceType) {
    SourceType["acl"] = "acl";
    SourceType["cluster"] = "cluster";
    SourceType["node"] = "node";
    SourceType["parameter_group"] = "parameter-group";
    SourceType["subnet_group"] = "subnet-group";
    SourceType["user"] = "user";
})(SourceType || (SourceType = {}));
export var DescribeEventsRequest;
(function (DescribeEventsRequest) {
    DescribeEventsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeEventsRequest || (DescribeEventsRequest = {}));
export var Event;
(function (Event) {
    Event.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Event || (Event = {}));
export var DescribeEventsResponse;
(function (DescribeEventsResponse) {
    DescribeEventsResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeEventsResponse || (DescribeEventsResponse = {}));
export var DescribeParameterGroupsRequest;
(function (DescribeParameterGroupsRequest) {
    DescribeParameterGroupsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeParameterGroupsRequest || (DescribeParameterGroupsRequest = {}));
export var DescribeParameterGroupsResponse;
(function (DescribeParameterGroupsResponse) {
    DescribeParameterGroupsResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeParameterGroupsResponse || (DescribeParameterGroupsResponse = {}));
export var DescribeParametersRequest;
(function (DescribeParametersRequest) {
    DescribeParametersRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeParametersRequest || (DescribeParametersRequest = {}));
export var Parameter;
(function (Parameter) {
    Parameter.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Parameter || (Parameter = {}));
export var DescribeParametersResponse;
(function (DescribeParametersResponse) {
    DescribeParametersResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeParametersResponse || (DescribeParametersResponse = {}));
export var DescribeServiceUpdatesRequest;
(function (DescribeServiceUpdatesRequest) {
    DescribeServiceUpdatesRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeServiceUpdatesRequest || (DescribeServiceUpdatesRequest = {}));
export var ServiceUpdateType;
(function (ServiceUpdateType) {
    ServiceUpdateType["SECURITY_UPDATE"] = "security-update";
})(ServiceUpdateType || (ServiceUpdateType = {}));
export var ServiceUpdate;
(function (ServiceUpdate) {
    ServiceUpdate.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ServiceUpdate || (ServiceUpdate = {}));
export var DescribeServiceUpdatesResponse;
(function (DescribeServiceUpdatesResponse) {
    DescribeServiceUpdatesResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeServiceUpdatesResponse || (DescribeServiceUpdatesResponse = {}));
export var DescribeSnapshotsRequest;
(function (DescribeSnapshotsRequest) {
    DescribeSnapshotsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeSnapshotsRequest || (DescribeSnapshotsRequest = {}));
export var DescribeSnapshotsResponse;
(function (DescribeSnapshotsResponse) {
    DescribeSnapshotsResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeSnapshotsResponse || (DescribeSnapshotsResponse = {}));
export var DescribeSubnetGroupsRequest;
(function (DescribeSubnetGroupsRequest) {
    DescribeSubnetGroupsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeSubnetGroupsRequest || (DescribeSubnetGroupsRequest = {}));
export var DescribeSubnetGroupsResponse;
(function (DescribeSubnetGroupsResponse) {
    DescribeSubnetGroupsResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeSubnetGroupsResponse || (DescribeSubnetGroupsResponse = {}));
export var Filter;
(function (Filter) {
    Filter.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Filter || (Filter = {}));
export var DescribeUsersRequest;
(function (DescribeUsersRequest) {
    DescribeUsersRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeUsersRequest || (DescribeUsersRequest = {}));
export var DescribeUsersResponse;
(function (DescribeUsersResponse) {
    DescribeUsersResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeUsersResponse || (DescribeUsersResponse = {}));
var APICallRateForCustomerExceededFault = (function (_super) {
    __extends(APICallRateForCustomerExceededFault, _super);
    function APICallRateForCustomerExceededFault(opts) {
        var _this = _super.call(this, __assign({ name: "APICallRateForCustomerExceededFault", $fault: "client" }, opts)) || this;
        _this.name = "APICallRateForCustomerExceededFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, APICallRateForCustomerExceededFault.prototype);
        return _this;
    }
    return APICallRateForCustomerExceededFault;
}(__BaseException));
export { APICallRateForCustomerExceededFault };
export var FailoverShardRequest;
(function (FailoverShardRequest) {
    FailoverShardRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(FailoverShardRequest || (FailoverShardRequest = {}));
export var FailoverShardResponse;
(function (FailoverShardResponse) {
    FailoverShardResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(FailoverShardResponse || (FailoverShardResponse = {}));
var InvalidKMSKeyFault = (function (_super) {
    __extends(InvalidKMSKeyFault, _super);
    function InvalidKMSKeyFault(opts) {
        var _this = _super.call(this, __assign({ name: "InvalidKMSKeyFault", $fault: "client" }, opts)) || this;
        _this.name = "InvalidKMSKeyFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, InvalidKMSKeyFault.prototype);
        return _this;
    }
    return InvalidKMSKeyFault;
}(__BaseException));
export { InvalidKMSKeyFault };
var ShardNotFoundFault = (function (_super) {
    __extends(ShardNotFoundFault, _super);
    function ShardNotFoundFault(opts) {
        var _this = _super.call(this, __assign({ name: "ShardNotFoundFault", $fault: "client" }, opts)) || this;
        _this.name = "ShardNotFoundFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ShardNotFoundFault.prototype);
        return _this;
    }
    return ShardNotFoundFault;
}(__BaseException));
export { ShardNotFoundFault };
var TestFailoverNotAvailableFault = (function (_super) {
    __extends(TestFailoverNotAvailableFault, _super);
    function TestFailoverNotAvailableFault(opts) {
        var _this = _super.call(this, __assign({ name: "TestFailoverNotAvailableFault", $fault: "client" }, opts)) || this;
        _this.name = "TestFailoverNotAvailableFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, TestFailoverNotAvailableFault.prototype);
        return _this;
    }
    return TestFailoverNotAvailableFault;
}(__BaseException));
export { TestFailoverNotAvailableFault };
export var ListAllowedNodeTypeUpdatesRequest;
(function (ListAllowedNodeTypeUpdatesRequest) {
    ListAllowedNodeTypeUpdatesRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListAllowedNodeTypeUpdatesRequest || (ListAllowedNodeTypeUpdatesRequest = {}));
export var ListAllowedNodeTypeUpdatesResponse;
(function (ListAllowedNodeTypeUpdatesResponse) {
    ListAllowedNodeTypeUpdatesResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListAllowedNodeTypeUpdatesResponse || (ListAllowedNodeTypeUpdatesResponse = {}));
var InvalidARNFault = (function (_super) {
    __extends(InvalidARNFault, _super);
    function InvalidARNFault(opts) {
        var _this = _super.call(this, __assign({ name: "InvalidARNFault", $fault: "client" }, opts)) || this;
        _this.name = "InvalidARNFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, InvalidARNFault.prototype);
        return _this;
    }
    return InvalidARNFault;
}(__BaseException));
export { InvalidARNFault };
export var ListTagsRequest;
(function (ListTagsRequest) {
    ListTagsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListTagsRequest || (ListTagsRequest = {}));
export var ListTagsResponse;
(function (ListTagsResponse) {
    ListTagsResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListTagsResponse || (ListTagsResponse = {}));
export var ResetParameterGroupRequest;
(function (ResetParameterGroupRequest) {
    ResetParameterGroupRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ResetParameterGroupRequest || (ResetParameterGroupRequest = {}));
export var ResetParameterGroupResponse;
(function (ResetParameterGroupResponse) {
    ResetParameterGroupResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ResetParameterGroupResponse || (ResetParameterGroupResponse = {}));
export var TagResourceRequest;
(function (TagResourceRequest) {
    TagResourceRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(TagResourceRequest || (TagResourceRequest = {}));
export var TagResourceResponse;
(function (TagResourceResponse) {
    TagResourceResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(TagResourceResponse || (TagResourceResponse = {}));
var TagNotFoundFault = (function (_super) {
    __extends(TagNotFoundFault, _super);
    function TagNotFoundFault(opts) {
        var _this = _super.call(this, __assign({ name: "TagNotFoundFault", $fault: "client" }, opts)) || this;
        _this.name = "TagNotFoundFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, TagNotFoundFault.prototype);
        return _this;
    }
    return TagNotFoundFault;
}(__BaseException));
export { TagNotFoundFault };
export var UntagResourceRequest;
(function (UntagResourceRequest) {
    UntagResourceRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UntagResourceRequest || (UntagResourceRequest = {}));
export var UntagResourceResponse;
(function (UntagResourceResponse) {
    UntagResourceResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UntagResourceResponse || (UntagResourceResponse = {}));
export var UpdateACLRequest;
(function (UpdateACLRequest) {
    UpdateACLRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateACLRequest || (UpdateACLRequest = {}));
export var UpdateACLResponse;
(function (UpdateACLResponse) {
    UpdateACLResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateACLResponse || (UpdateACLResponse = {}));
var InvalidNodeStateFault = (function (_super) {
    __extends(InvalidNodeStateFault, _super);
    function InvalidNodeStateFault(opts) {
        var _this = _super.call(this, __assign({ name: "InvalidNodeStateFault", $fault: "client" }, opts)) || this;
        _this.name = "InvalidNodeStateFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, InvalidNodeStateFault.prototype);
        return _this;
    }
    return InvalidNodeStateFault;
}(__BaseException));
export { InvalidNodeStateFault };
var NoOperationFault = (function (_super) {
    __extends(NoOperationFault, _super);
    function NoOperationFault(opts) {
        var _this = _super.call(this, __assign({ name: "NoOperationFault", $fault: "client" }, opts)) || this;
        _this.name = "NoOperationFault";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, NoOperationFault.prototype);
        return _this;
    }
    return NoOperationFault;
}(__BaseException));
export { NoOperationFault };
export var ReplicaConfigurationRequest;
(function (ReplicaConfigurationRequest) {
    ReplicaConfigurationRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ReplicaConfigurationRequest || (ReplicaConfigurationRequest = {}));
export var ShardConfigurationRequest;
(function (ShardConfigurationRequest) {
    ShardConfigurationRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ShardConfigurationRequest || (ShardConfigurationRequest = {}));
export var UpdateClusterRequest;
(function (UpdateClusterRequest) {
    UpdateClusterRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateClusterRequest || (UpdateClusterRequest = {}));
export var UpdateClusterResponse;
(function (UpdateClusterResponse) {
    UpdateClusterResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateClusterResponse || (UpdateClusterResponse = {}));
export var ParameterNameValue;
(function (ParameterNameValue) {
    ParameterNameValue.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ParameterNameValue || (ParameterNameValue = {}));
export var UpdateParameterGroupRequest;
(function (UpdateParameterGroupRequest) {
    UpdateParameterGroupRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateParameterGroupRequest || (UpdateParameterGroupRequest = {}));
export var UpdateParameterGroupResponse;
(function (UpdateParameterGroupResponse) {
    UpdateParameterGroupResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateParameterGroupResponse || (UpdateParameterGroupResponse = {}));
var SubnetInUse = (function (_super) {
    __extends(SubnetInUse, _super);
    function SubnetInUse(opts) {
        var _this = _super.call(this, __assign({ name: "SubnetInUse", $fault: "client" }, opts)) || this;
        _this.name = "SubnetInUse";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, SubnetInUse.prototype);
        return _this;
    }
    return SubnetInUse;
}(__BaseException));
export { SubnetInUse };
export var UpdateSubnetGroupRequest;
(function (UpdateSubnetGroupRequest) {
    UpdateSubnetGroupRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateSubnetGroupRequest || (UpdateSubnetGroupRequest = {}));
export var UpdateSubnetGroupResponse;
(function (UpdateSubnetGroupResponse) {
    UpdateSubnetGroupResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateSubnetGroupResponse || (UpdateSubnetGroupResponse = {}));
export var UpdateUserRequest;
(function (UpdateUserRequest) {
    UpdateUserRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateUserRequest || (UpdateUserRequest = {}));
export var UpdateUserResponse;
(function (UpdateUserResponse) {
    UpdateUserResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateUserResponse || (UpdateUserResponse = {}));
